/* contacts-store.c generated by valac 0.44.0, the Vala compiler
 * generated from contacts-store.vala, do not modify */

/*
 * Copyright (C) 2011 Alexander Larsson <alexl@redhat.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <folks/folks.h>
#include <glib/gstdio.h>
#include <gio/gio.h>

#define CONTACTS_TYPE_STORE (contacts_store_get_type ())
#define CONTACTS_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTACTS_TYPE_STORE, ContactsStore))
#define CONTACTS_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTACTS_TYPE_STORE, ContactsStoreClass))
#define CONTACTS_IS_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTACTS_TYPE_STORE))
#define CONTACTS_IS_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTACTS_TYPE_STORE))
#define CONTACTS_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTACTS_TYPE_STORE, ContactsStoreClass))

typedef struct _ContactsStore ContactsStore;
typedef struct _ContactsStoreClass ContactsStoreClass;
typedef struct _ContactsStorePrivate ContactsStorePrivate;

#define CONTACTS_TYPE_CONTACT (contacts_contact_get_type ())
#define CONTACTS_CONTACT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTACTS_TYPE_CONTACT, ContactsContact))
#define CONTACTS_CONTACT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTACTS_TYPE_CONTACT, ContactsContactClass))
#define CONTACTS_IS_CONTACT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTACTS_TYPE_CONTACT))
#define CONTACTS_IS_CONTACT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTACTS_TYPE_CONTACT))
#define CONTACTS_CONTACT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTACTS_TYPE_CONTACT, ContactsContactClass))

typedef struct _ContactsContact ContactsContact;
typedef struct _ContactsContactClass ContactsContactClass;
enum  {
	CONTACTS_STORE_0_PROPERTY,
	CONTACTS_STORE_AGGREGATOR_PROPERTY,
	CONTACTS_STORE_BACKEND_STORE_PROPERTY,
	CONTACTS_STORE_IS_QUIESCENT_PROPERTY,
	CONTACTS_STORE_IS_PREPARED_PROPERTY,
	CONTACTS_STORE_NUM_PROPERTIES
};
static GParamSpec* contacts_store_properties[CONTACTS_STORE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _ContactsContactPrivate ContactsContactPrivate;
typedef gboolean (*ContactsStoreContactMatcher) (ContactsContact* c, gpointer user_data);
typedef struct _Block2Data Block2Data;
typedef struct _ContactsStoreFindContactData ContactsStoreFindContactData;
enum  {
	CONTACTS_STORE_ADDED_SIGNAL,
	CONTACTS_STORE_REMOVED_SIGNAL,
	CONTACTS_STORE_QUIESCENT_SIGNAL,
	CONTACTS_STORE_PREPARED_SIGNAL,
	CONTACTS_STORE_NUM_SIGNALS
};
static guint contacts_store_signals[CONTACTS_STORE_NUM_SIGNALS] = {0};

struct _ContactsStore {
	GObject parent_instance;
	ContactsStorePrivate * priv;
	GeeHashMultiMap* dont_suggest_link;
};

struct _ContactsStoreClass {
	GObjectClass parent_class;
};

struct _ContactsStorePrivate {
	FolksIndividualAggregator* _aggregator;
	GeeArrayList* contacts;
};

struct _ContactsContact {
	GObject parent_instance;
	ContactsContactPrivate * priv;
	gboolean is_main;
	FolksIndividual* individual;
	FolksPersona* fake_persona;
};

struct _ContactsContactClass {
	GObjectClass parent_class;
};

struct _Block2Data {
	int _ref_count_;
	ContactsStore* self;
	ContactsContact* matched;
	GSourceFunc callback;
	gpointer callback_target;
	GDestroyNotify callback_target_destroy_notify;
	ContactsStoreContactMatcher matcher;
	gpointer matcher_target;
	gpointer _async_data_;
};

struct _ContactsStoreFindContactData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ContactsStore* self;
	ContactsStoreContactMatcher matcher;
	gpointer matcher_target;
	ContactsContact* result;
	Block2Data* _data2_;
	GeeArrayList* _c_list;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	gint _c_size;
	GeeArrayList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _c_index;
	ContactsContact* c;
	GeeArrayList* _tmp5_;
	gpointer _tmp6_;
	ContactsContact* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	gulong id2;
	gulong id3;
	gulong _tmp10_;
	gulong _tmp11_;
	ContactsContact* _tmp12_;
	ContactsContact* _tmp13_;
};

static gint ContactsStore_private_offset;
static gpointer contacts_store_parent_class = NULL;

GType contacts_store_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ContactsStore, g_object_unref)
GType contacts_contact_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ContactsContact, g_object_unref)
void contacts_store_refresh (ContactsStore* self);
gboolean contacts_contact_update (ContactsContact* self);
static gboolean contacts_store_individual_can_replace_at_split (ContactsStore* self,
                                                         FolksIndividual* new_individual);
static gboolean contacts_store_individual_should_replace_at_join (ContactsStore* self,
                                                           FolksIndividual* old_individual);
ContactsContact* contacts_contact_from_individual (FolksIndividual* i);
static void contacts_store_read_dont_suggest_db (ContactsStore* self);
static void contacts_store_write_dont_suggest_db (ContactsStore* self);
gboolean contacts_store_may_suggest_link (ContactsStore* self,
                                          ContactsContact* a,
                                          ContactsContact* b);
void contacts_store_add_no_suggest_link (ContactsStore* self,
                                         ContactsContact* a,
                                         ContactsContact* b);
GeeList* contacts_contact_get_personas_for_display (ContactsContact* self);
static void contacts_store_on_individuals_changed_detailed (ContactsStore* self,
                                                     GeeMultiMap* changes);
static void contacts_store_remove (ContactsStore* self,
                            ContactsContact* c);
static void contacts_store_add (ContactsStore* self,
                         ContactsContact* c);
ContactsContact* contacts_contact_new (ContactsStore* store,
                                       FolksIndividual* i);
ContactsContact* contacts_contact_construct (GType object_type,
                                             ContactsStore* store,
                                             FolksIndividual* i);
void contacts_contact_replace_individual (ContactsContact* self,
                                          FolksIndividual* new_individual);
static void contacts_store_find_contact_data_free (gpointer _data);
void contacts_store_find_contact (ContactsStore* self,
                                  ContactsStoreContactMatcher matcher,
                                  gpointer matcher_target,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_);
ContactsContact* contacts_store_find_contact_finish (ContactsStore* self,
                                                     GAsyncResult* _res_);
static gboolean contacts_store_find_contact_co (ContactsStoreFindContactData* _data_);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
gboolean contacts_store_get_is_quiescent (ContactsStore* self);
static gboolean _contacts_store_find_contact_co_gsource_func (gpointer self);
static void __lambda5_ (Block2Data* _data2_,
                 ContactsContact* c);
static void ___lambda5__contacts_store_added (ContactsStore* _sender,
                                       ContactsContact* c,
                                       gpointer self);
static void __lambda6_ (Block2Data* _data2_);
static void ___lambda6__contacts_store_quiescent (ContactsStore* _sender,
                                           gpointer self);
ContactsContact* contacts_store_find_contact_with_persona (ContactsStore* self,
                                                           FolksPersona* persona);
GeeCollection* contacts_store_get_contacts (ContactsStore* self);
ContactsStore* contacts_store_new (void);
ContactsStore* contacts_store_construct (GType object_type);
FolksIndividualAggregator* contacts_store_get_aggregator (ContactsStore* self);
static void contacts_store_set_aggregator (ContactsStore* self,
                                    FolksIndividualAggregator* value);
FolksBackendStore* contacts_store_get_backend_store (ContactsStore* self);
gboolean contacts_store_get_is_prepared (ContactsStore* self);
static GObject * contacts_store_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static void _contacts_store___lambda7_ (ContactsStore* self,
                                 GObject* obj,
                                 GParamSpec* pspec);
static gboolean __lambda8_ (ContactsStore* self);
static gboolean ___lambda8__gsource_func (gpointer self);
static void __contacts_store___lambda7__g_object_notify (GObject* _sender,
                                                  GParamSpec* pspec,
                                                  gpointer self);
static void _contacts_store___lambda9_ (ContactsStore* self,
                                 GObject* obj,
                                 GParamSpec* pspec);
static gboolean __lambda10_ (ContactsStore* self);
static gboolean ___lambda10__gsource_func (gpointer self);
static void __contacts_store___lambda9__g_object_notify (GObject* _sender,
                                                  GParamSpec* pspec,
                                                  gpointer self);
static void _contacts_store_on_individuals_changed_detailed_folks_individual_aggregator_individuals_changed_detailed (FolksIndividualAggregator* _sender,
                                                                                                               GeeMultiMap* changes,
                                                                                                               gpointer self);
static void contacts_store_finalize (GObject * obj);
static void _vala_contacts_store_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_contacts_store_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
contacts_store_get_instance_private (ContactsStore* self)
{
	return G_STRUCT_MEMBER_P (self, ContactsStore_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 47 "../src/contacts-store.vala"
	return self ? g_object_ref (self) : NULL;
#line 265 "contacts-store.c"
}

void
contacts_store_refresh (ContactsStore* self)
{
#line 46 "../src/contacts-store.vala"
	g_return_if_fail (self != NULL);
#line 273 "contacts-store.c"
	{
		GeeArrayList* _c_list = NULL;
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _c_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _c_index = 0;
#line 47 "../src/contacts-store.vala"
		_tmp0_ = self->priv->contacts;
#line 47 "../src/contacts-store.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 47 "../src/contacts-store.vala"
		_c_list = _tmp1_;
#line 47 "../src/contacts-store.vala"
		_tmp2_ = _c_list;
#line 47 "../src/contacts-store.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 47 "../src/contacts-store.vala"
		_tmp4_ = _tmp3_;
#line 47 "../src/contacts-store.vala"
		_c_size = _tmp4_;
#line 47 "../src/contacts-store.vala"
		_c_index = -1;
#line 47 "../src/contacts-store.vala"
		while (TRUE) {
#line 301 "contacts-store.c"
			ContactsContact* c = NULL;
			GeeArrayList* _tmp5_;
			gpointer _tmp6_;
			ContactsContact* _tmp7_;
#line 47 "../src/contacts-store.vala"
			_c_index = _c_index + 1;
#line 47 "../src/contacts-store.vala"
			if (!(_c_index < _c_size)) {
#line 47 "../src/contacts-store.vala"
				break;
#line 312 "contacts-store.c"
			}
#line 47 "../src/contacts-store.vala"
			_tmp5_ = _c_list;
#line 47 "../src/contacts-store.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _c_index);
#line 47 "../src/contacts-store.vala"
			c = (ContactsContact*) _tmp6_;
#line 48 "../src/contacts-store.vala"
			_tmp7_ = c;
#line 48 "../src/contacts-store.vala"
			contacts_contact_update (_tmp7_);
#line 47 "../src/contacts-store.vala"
			_g_object_unref0 (c);
#line 326 "contacts-store.c"
		}
#line 47 "../src/contacts-store.vala"
		_g_object_unref0 (_c_list);
#line 330 "contacts-store.c"
	}
}

static gboolean
contacts_store_individual_can_replace_at_split (ContactsStore* self,
                                                FolksIndividual* new_individual)
{
	gboolean result = FALSE;
#line 51 "../src/contacts-store.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 51 "../src/contacts-store.vala"
	g_return_val_if_fail (new_individual != NULL, FALSE);
#line 343 "contacts-store.c"
	{
		GeeIterator* _p_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeIterator* _tmp2_;
#line 52 "../src/contacts-store.vala"
		_tmp0_ = folks_individual_get_personas (new_individual);
#line 52 "../src/contacts-store.vala"
		_tmp1_ = _tmp0_;
#line 52 "../src/contacts-store.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 52 "../src/contacts-store.vala"
		_p_it = _tmp2_;
#line 52 "../src/contacts-store.vala"
		while (TRUE) {
#line 359 "contacts-store.c"
			GeeIterator* _tmp3_;
			FolksPersona* p = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			FolksPersona* _tmp6_;
			gconstpointer _tmp7_;
#line 52 "../src/contacts-store.vala"
			_tmp3_ = _p_it;
#line 52 "../src/contacts-store.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 52 "../src/contacts-store.vala"
				break;
#line 372 "contacts-store.c"
			}
#line 52 "../src/contacts-store.vala"
			_tmp4_ = _p_it;
#line 52 "../src/contacts-store.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 52 "../src/contacts-store.vala"
			p = (FolksPersona*) _tmp5_;
#line 53 "../src/contacts-store.vala"
			_tmp6_ = p;
#line 53 "../src/contacts-store.vala"
			_tmp7_ = g_object_get_data ((GObject*) _tmp6_, "contacts-new-contact");
#line 53 "../src/contacts-store.vala"
			if ((gboolean) ((gintptr) _tmp7_)) {
#line 54 "../src/contacts-store.vala"
				result = FALSE;
#line 54 "../src/contacts-store.vala"
				_g_object_unref0 (p);
#line 54 "../src/contacts-store.vala"
				_g_object_unref0 (_p_it);
#line 54 "../src/contacts-store.vala"
				return result;
#line 394 "contacts-store.c"
			}
#line 52 "../src/contacts-store.vala"
			_g_object_unref0 (p);
#line 398 "contacts-store.c"
		}
#line 52 "../src/contacts-store.vala"
		_g_object_unref0 (_p_it);
#line 402 "contacts-store.c"
	}
#line 56 "../src/contacts-store.vala"
	result = TRUE;
#line 56 "../src/contacts-store.vala"
	return result;
#line 408 "contacts-store.c"
}

static gboolean
contacts_store_individual_should_replace_at_join (ContactsStore* self,
                                                  FolksIndividual* old_individual)
{
	gboolean result = FALSE;
	ContactsContact* c = NULL;
	ContactsContact* _tmp0_;
	ContactsContact* _tmp1_;
	gconstpointer _tmp2_;
#line 59 "../src/contacts-store.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 59 "../src/contacts-store.vala"
	g_return_val_if_fail (old_individual != NULL, FALSE);
#line 60 "../src/contacts-store.vala"
	_tmp0_ = contacts_contact_from_individual (old_individual);
#line 60 "../src/contacts-store.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 60 "../src/contacts-store.vala"
	c = _tmp1_;
#line 61 "../src/contacts-store.vala"
	_tmp2_ = g_object_get_data ((GObject*) c, "contacts-master-at-join");
#line 61 "../src/contacts-store.vala"
	result = (gboolean) ((gintptr) _tmp2_);
#line 61 "../src/contacts-store.vala"
	_g_object_unref0 (c);
#line 61 "../src/contacts-store.vala"
	return result;
#line 438 "contacts-store.c"
}

static void
contacts_store_read_dont_suggest_db (ContactsStore* self)
{
	GeeHashMultiMap* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 64 "../src/contacts-store.vala"
	g_return_if_fail (self != NULL);
#line 65 "../src/contacts-store.vala"
	_tmp0_ = self->dont_suggest_link;
#line 65 "../src/contacts-store.vala"
	gee_multi_map_clear ((GeeMultiMap*) _tmp0_);
#line 452 "contacts-store.c"
	{
		gchar* path = NULL;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* contents = NULL;
		gboolean _tmp3_ = FALSE;
		gchar* _tmp4_ = NULL;
		gboolean _tmp5_;
#line 67 "../src/contacts-store.vala"
		_tmp1_ = g_get_user_config_dir ();
#line 67 "../src/contacts-store.vala"
		_tmp2_ = g_build_filename (_tmp1_, "gnome-contacts", "dont_suggest.db", NULL);
#line 67 "../src/contacts-store.vala"
		path = _tmp2_;
#line 69 "../src/contacts-store.vala"
		_tmp5_ = g_file_get_contents (path, &_tmp4_, NULL, &_inner_error0_);
#line 69 "../src/contacts-store.vala"
		_g_free0 (contents);
#line 69 "../src/contacts-store.vala"
		contents = _tmp4_;
#line 69 "../src/contacts-store.vala"
		_tmp3_ = _tmp5_;
#line 69 "../src/contacts-store.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 69 "../src/contacts-store.vala"
			_g_free0 (contents);
#line 69 "../src/contacts-store.vala"
			_g_free0 (path);
#line 481 "contacts-store.c"
			goto __catch5_g_error;
		}
#line 69 "../src/contacts-store.vala"
		if (_tmp3_) {
#line 486 "contacts-store.c"
			gchar** rows = NULL;
			gchar** _tmp6_;
			gchar** _tmp7_;
			gint rows_length1;
			gint _rows_size_;
			gchar** _tmp8_;
			gint _tmp8__length1;
#line 70 "../src/contacts-store.vala"
			_tmp7_ = _tmp6_ = g_strsplit (contents, "\n", 0);
#line 70 "../src/contacts-store.vala"
			rows = _tmp7_;
#line 70 "../src/contacts-store.vala"
			rows_length1 = _vala_array_length (_tmp6_);
#line 70 "../src/contacts-store.vala"
			_rows_size_ = rows_length1;
#line 71 "../src/contacts-store.vala"
			_tmp8_ = rows;
#line 71 "../src/contacts-store.vala"
			_tmp8__length1 = rows_length1;
#line 506 "contacts-store.c"
			{
				gchar** r_collection = NULL;
				gint r_collection_length1 = 0;
				gint _r_collection_size_ = 0;
				gint r_it = 0;
#line 71 "../src/contacts-store.vala"
				r_collection = _tmp8_;
#line 71 "../src/contacts-store.vala"
				r_collection_length1 = _tmp8__length1;
#line 71 "../src/contacts-store.vala"
				for (r_it = 0; r_it < _tmp8__length1; r_it = r_it + 1) {
#line 518 "contacts-store.c"
					gchar* _tmp9_;
					gchar* r = NULL;
#line 71 "../src/contacts-store.vala"
					_tmp9_ = g_strdup (r_collection[r_it]);
#line 71 "../src/contacts-store.vala"
					r = _tmp9_;
#line 525 "contacts-store.c"
					{
						gchar** ids = NULL;
						const gchar* _tmp10_;
						gchar** _tmp11_;
						gchar** _tmp12_;
						gint ids_length1;
						gint _ids_size_;
						gchar** _tmp13_;
						gint _tmp13__length1;
#line 72 "../src/contacts-store.vala"
						_tmp10_ = r;
#line 72 "../src/contacts-store.vala"
						_tmp12_ = _tmp11_ = g_strsplit (_tmp10_, " ", 0);
#line 72 "../src/contacts-store.vala"
						ids = _tmp12_;
#line 72 "../src/contacts-store.vala"
						ids_length1 = _vala_array_length (_tmp11_);
#line 72 "../src/contacts-store.vala"
						_ids_size_ = ids_length1;
#line 73 "../src/contacts-store.vala"
						_tmp13_ = ids;
#line 73 "../src/contacts-store.vala"
						_tmp13__length1 = ids_length1;
#line 73 "../src/contacts-store.vala"
						if (_tmp13__length1 == 2) {
#line 551 "contacts-store.c"
							GeeHashMultiMap* _tmp14_;
							gchar** _tmp15_;
							gint _tmp15__length1;
							const gchar* _tmp16_;
							gchar** _tmp17_;
							gint _tmp17__length1;
							const gchar* _tmp18_;
#line 74 "../src/contacts-store.vala"
							_tmp14_ = self->dont_suggest_link;
#line 74 "../src/contacts-store.vala"
							_tmp15_ = ids;
#line 74 "../src/contacts-store.vala"
							_tmp15__length1 = ids_length1;
#line 74 "../src/contacts-store.vala"
							_tmp16_ = _tmp15_[0];
#line 74 "../src/contacts-store.vala"
							_tmp17_ = ids;
#line 74 "../src/contacts-store.vala"
							_tmp17__length1 = ids_length1;
#line 74 "../src/contacts-store.vala"
							_tmp18_ = _tmp17_[1];
#line 74 "../src/contacts-store.vala"
							gee_multi_map_set ((GeeMultiMap*) _tmp14_, _tmp16_, _tmp18_);
#line 575 "contacts-store.c"
						}
#line 71 "../src/contacts-store.vala"
						ids = (_vala_array_free (ids, ids_length1, (GDestroyNotify) g_free), NULL);
#line 71 "../src/contacts-store.vala"
						_g_free0 (r);
#line 581 "contacts-store.c"
					}
				}
			}
#line 69 "../src/contacts-store.vala"
			rows = (_vala_array_free (rows, rows_length1, (GDestroyNotify) g_free), NULL);
#line 587 "contacts-store.c"
		}
#line 66 "../src/contacts-store.vala"
		_g_free0 (contents);
#line 66 "../src/contacts-store.vala"
		_g_free0 (path);
#line 593 "contacts-store.c"
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		GError* _tmp19_;
#line 66 "../src/contacts-store.vala"
		e = _inner_error0_;
#line 66 "../src/contacts-store.vala"
		_inner_error0_ = NULL;
#line 79 "../src/contacts-store.vala"
		_tmp19_ = e;
#line 79 "../src/contacts-store.vala"
		if (!g_error_matches (_tmp19_, G_FILE_ERROR, G_FILE_ERROR_NOENT)) {
#line 608 "contacts-store.c"
			GError* _tmp20_;
			const gchar* _tmp21_;
#line 80 "../src/contacts-store.vala"
			_tmp20_ = e;
#line 80 "../src/contacts-store.vala"
			_tmp21_ = _tmp20_->message;
#line 80 "../src/contacts-store.vala"
			g_warning ("contacts-store.vala:80: error loading no suggestion db: %s\n", _tmp21_);
#line 617 "contacts-store.c"
		}
#line 66 "../src/contacts-store.vala"
		_g_error_free0 (e);
#line 621 "contacts-store.c"
	}
	__finally5:
#line 66 "../src/contacts-store.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 66 "../src/contacts-store.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 66 "../src/contacts-store.vala"
		g_clear_error (&_inner_error0_);
#line 66 "../src/contacts-store.vala"
		return;
#line 632 "contacts-store.c"
	}
}

static void
contacts_store_write_dont_suggest_db (ContactsStore* self)
{
	GError* _inner_error0_ = NULL;
#line 84 "../src/contacts-store.vala"
	g_return_if_fail (self != NULL);
#line 642 "contacts-store.c"
	{
		gchar* dir = NULL;
		const gchar* _tmp0_;
		gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* path = NULL;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		GString* s = NULL;
		GString* _tmp5_;
		const gchar* _tmp26_;
		GString* _tmp27_;
		const gchar* _tmp28_;
		GString* _tmp29_;
#line 86 "../src/contacts-store.vala"
		_tmp0_ = g_get_user_config_dir ();
#line 86 "../src/contacts-store.vala"
		_tmp1_ = g_build_filename (_tmp0_, "gnome-contacts", NULL);
#line 86 "../src/contacts-store.vala"
		dir = _tmp1_;
#line 87 "../src/contacts-store.vala"
		_tmp2_ = dir;
#line 87 "../src/contacts-store.vala"
		g_mkdir_with_parents (_tmp2_, 0700);
#line 88 "../src/contacts-store.vala"
		_tmp3_ = dir;
#line 88 "../src/contacts-store.vala"
		_tmp4_ = g_build_filename (_tmp3_, "dont_suggest.db", NULL);
#line 88 "../src/contacts-store.vala"
		path = _tmp4_;
#line 90 "../src/contacts-store.vala"
		_tmp5_ = g_string_new ("");
#line 90 "../src/contacts-store.vala"
		s = _tmp5_;
#line 677 "contacts-store.c"
		{
			GeeIterator* _key_it = NULL;
			GeeHashMultiMap* _tmp6_;
			GeeSet* _tmp7_;
			GeeSet* _tmp8_;
			GeeIterator* _tmp9_;
			GeeIterator* _tmp10_;
#line 91 "../src/contacts-store.vala"
			_tmp6_ = self->dont_suggest_link;
#line 91 "../src/contacts-store.vala"
			_tmp7_ = gee_multi_map_get_keys ((GeeMultiMap*) _tmp6_);
#line 91 "../src/contacts-store.vala"
			_tmp8_ = _tmp7_;
#line 91 "../src/contacts-store.vala"
			_tmp9_ = gee_iterable_iterator ((GeeIterable*) _tmp8_);
#line 91 "../src/contacts-store.vala"
			_tmp10_ = _tmp9_;
#line 91 "../src/contacts-store.vala"
			_g_object_unref0 (_tmp8_);
#line 91 "../src/contacts-store.vala"
			_key_it = _tmp10_;
#line 91 "../src/contacts-store.vala"
			while (TRUE) {
#line 701 "contacts-store.c"
				GeeIterator* _tmp11_;
				gchar* key = NULL;
				GeeIterator* _tmp12_;
				gpointer _tmp13_;
#line 91 "../src/contacts-store.vala"
				_tmp11_ = _key_it;
#line 91 "../src/contacts-store.vala"
				if (!gee_iterator_next (_tmp11_)) {
#line 91 "../src/contacts-store.vala"
					break;
#line 712 "contacts-store.c"
				}
#line 91 "../src/contacts-store.vala"
				_tmp12_ = _key_it;
#line 91 "../src/contacts-store.vala"
				_tmp13_ = gee_iterator_get (_tmp12_);
#line 91 "../src/contacts-store.vala"
				key = (gchar*) _tmp13_;
#line 720 "contacts-store.c"
				{
					GeeIterator* _value_it = NULL;
					GeeHashMultiMap* _tmp14_;
					const gchar* _tmp15_;
					GeeCollection* _tmp16_;
					GeeCollection* _tmp17_;
					GeeIterator* _tmp18_;
					GeeIterator* _tmp19_;
#line 92 "../src/contacts-store.vala"
					_tmp14_ = self->dont_suggest_link;
#line 92 "../src/contacts-store.vala"
					_tmp15_ = key;
#line 92 "../src/contacts-store.vala"
					_tmp16_ = gee_multi_map_get ((GeeMultiMap*) _tmp14_, _tmp15_);
#line 92 "../src/contacts-store.vala"
					_tmp17_ = _tmp16_;
#line 92 "../src/contacts-store.vala"
					_tmp18_ = gee_iterable_iterator ((GeeIterable*) _tmp17_);
#line 92 "../src/contacts-store.vala"
					_tmp19_ = _tmp18_;
#line 92 "../src/contacts-store.vala"
					_g_object_unref0 (_tmp17_);
#line 92 "../src/contacts-store.vala"
					_value_it = _tmp19_;
#line 92 "../src/contacts-store.vala"
					while (TRUE) {
#line 747 "contacts-store.c"
						GeeIterator* _tmp20_;
						gchar* value = NULL;
						GeeIterator* _tmp21_;
						gpointer _tmp22_;
						GString* _tmp23_;
						const gchar* _tmp24_;
						const gchar* _tmp25_;
#line 92 "../src/contacts-store.vala"
						_tmp20_ = _value_it;
#line 92 "../src/contacts-store.vala"
						if (!gee_iterator_next (_tmp20_)) {
#line 92 "../src/contacts-store.vala"
							break;
#line 761 "contacts-store.c"
						}
#line 92 "../src/contacts-store.vala"
						_tmp21_ = _value_it;
#line 92 "../src/contacts-store.vala"
						_tmp22_ = gee_iterator_get (_tmp21_);
#line 92 "../src/contacts-store.vala"
						value = (gchar*) _tmp22_;
#line 93 "../src/contacts-store.vala"
						_tmp23_ = s;
#line 93 "../src/contacts-store.vala"
						_tmp24_ = key;
#line 93 "../src/contacts-store.vala"
						_tmp25_ = value;
#line 93 "../src/contacts-store.vala"
						g_string_append_printf (_tmp23_, "%s %s\n", _tmp24_, _tmp25_);
#line 92 "../src/contacts-store.vala"
						_g_free0 (value);
#line 779 "contacts-store.c"
					}
#line 92 "../src/contacts-store.vala"
					_g_object_unref0 (_value_it);
#line 783 "contacts-store.c"
				}
#line 91 "../src/contacts-store.vala"
				_g_free0 (key);
#line 787 "contacts-store.c"
			}
#line 91 "../src/contacts-store.vala"
			_g_object_unref0 (_key_it);
#line 791 "contacts-store.c"
		}
#line 96 "../src/contacts-store.vala"
		_tmp26_ = path;
#line 96 "../src/contacts-store.vala"
		_tmp27_ = s;
#line 96 "../src/contacts-store.vala"
		_tmp28_ = _tmp27_->str;
#line 96 "../src/contacts-store.vala"
		_tmp29_ = s;
#line 96 "../src/contacts-store.vala"
		g_file_set_contents (_tmp26_, _tmp28_, _tmp29_->len, &_inner_error0_);
#line 96 "../src/contacts-store.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 96 "../src/contacts-store.vala"
			_g_string_free0 (s);
#line 96 "../src/contacts-store.vala"
			_g_free0 (path);
#line 96 "../src/contacts-store.vala"
			_g_free0 (dir);
#line 811 "contacts-store.c"
			goto __catch6_g_error;
		}
#line 85 "../src/contacts-store.vala"
		_g_string_free0 (s);
#line 85 "../src/contacts-store.vala"
		_g_free0 (path);
#line 85 "../src/contacts-store.vala"
		_g_free0 (dir);
#line 820 "contacts-store.c"
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError* e = NULL;
		GError* _tmp30_;
		const gchar* _tmp31_;
#line 85 "../src/contacts-store.vala"
		e = _inner_error0_;
#line 85 "../src/contacts-store.vala"
		_inner_error0_ = NULL;
#line 98 "../src/contacts-store.vala"
		_tmp30_ = e;
#line 98 "../src/contacts-store.vala"
		_tmp31_ = _tmp30_->message;
#line 98 "../src/contacts-store.vala"
		g_warning ("contacts-store.vala:98: error writing no suggestion db: %s\n", _tmp31_);
#line 85 "../src/contacts-store.vala"
		_g_error_free0 (e);
#line 840 "contacts-store.c"
	}
	__finally6:
#line 85 "../src/contacts-store.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 85 "../src/contacts-store.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 85 "../src/contacts-store.vala"
		g_clear_error (&_inner_error0_);
#line 85 "../src/contacts-store.vala"
		return;
#line 851 "contacts-store.c"
	}
}

gboolean
contacts_store_may_suggest_link (ContactsStore* self,
                                 ContactsContact* a,
                                 ContactsContact* b)
{
	gboolean result = FALSE;
#line 102 "../src/contacts-store.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 102 "../src/contacts-store.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 102 "../src/contacts-store.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 867 "contacts-store.c"
	{
		GeeIterator* _a_persona_it = NULL;
		FolksIndividual* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
#line 103 "../src/contacts-store.vala"
		_tmp0_ = a->individual;
#line 103 "../src/contacts-store.vala"
		_tmp1_ = folks_individual_get_personas (_tmp0_);
#line 103 "../src/contacts-store.vala"
		_tmp2_ = _tmp1_;
#line 103 "../src/contacts-store.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 103 "../src/contacts-store.vala"
		_a_persona_it = _tmp3_;
#line 103 "../src/contacts-store.vala"
		while (TRUE) {
#line 886 "contacts-store.c"
			GeeIterator* _tmp4_;
			FolksPersona* a_persona = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
#line 103 "../src/contacts-store.vala"
			_tmp4_ = _a_persona_it;
#line 103 "../src/contacts-store.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 103 "../src/contacts-store.vala"
				break;
#line 897 "contacts-store.c"
			}
#line 103 "../src/contacts-store.vala"
			_tmp5_ = _a_persona_it;
#line 103 "../src/contacts-store.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 103 "../src/contacts-store.vala"
			a_persona = (FolksPersona*) _tmp6_;
#line 905 "contacts-store.c"
			{
				GeeIterator* _no_link_uid_it = NULL;
				GeeHashMultiMap* _tmp7_;
				FolksPersona* _tmp8_;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				GeeCollection* _tmp11_;
				GeeCollection* _tmp12_;
				GeeIterator* _tmp13_;
				GeeIterator* _tmp14_;
#line 104 "../src/contacts-store.vala"
				_tmp7_ = self->dont_suggest_link;
#line 104 "../src/contacts-store.vala"
				_tmp8_ = a_persona;
#line 104 "../src/contacts-store.vala"
				_tmp9_ = folks_persona_get_uid (_tmp8_);
#line 104 "../src/contacts-store.vala"
				_tmp10_ = _tmp9_;
#line 104 "../src/contacts-store.vala"
				_tmp11_ = gee_multi_map_get ((GeeMultiMap*) _tmp7_, _tmp10_);
#line 104 "../src/contacts-store.vala"
				_tmp12_ = _tmp11_;
#line 104 "../src/contacts-store.vala"
				_tmp13_ = gee_iterable_iterator ((GeeIterable*) _tmp12_);
#line 104 "../src/contacts-store.vala"
				_tmp14_ = _tmp13_;
#line 104 "../src/contacts-store.vala"
				_g_object_unref0 (_tmp12_);
#line 104 "../src/contacts-store.vala"
				_no_link_uid_it = _tmp14_;
#line 104 "../src/contacts-store.vala"
				while (TRUE) {
#line 938 "contacts-store.c"
					GeeIterator* _tmp15_;
					gchar* no_link_uid = NULL;
					GeeIterator* _tmp16_;
					gpointer _tmp17_;
#line 104 "../src/contacts-store.vala"
					_tmp15_ = _no_link_uid_it;
#line 104 "../src/contacts-store.vala"
					if (!gee_iterator_next (_tmp15_)) {
#line 104 "../src/contacts-store.vala"
						break;
#line 949 "contacts-store.c"
					}
#line 104 "../src/contacts-store.vala"
					_tmp16_ = _no_link_uid_it;
#line 104 "../src/contacts-store.vala"
					_tmp17_ = gee_iterator_get (_tmp16_);
#line 104 "../src/contacts-store.vala"
					no_link_uid = (gchar*) _tmp17_;
#line 957 "contacts-store.c"
					{
						GeeIterator* _b_persona_it = NULL;
						FolksIndividual* _tmp18_;
						GeeSet* _tmp19_;
						GeeSet* _tmp20_;
						GeeIterator* _tmp21_;
#line 105 "../src/contacts-store.vala"
						_tmp18_ = b->individual;
#line 105 "../src/contacts-store.vala"
						_tmp19_ = folks_individual_get_personas (_tmp18_);
#line 105 "../src/contacts-store.vala"
						_tmp20_ = _tmp19_;
#line 105 "../src/contacts-store.vala"
						_tmp21_ = gee_iterable_iterator ((GeeIterable*) _tmp20_);
#line 105 "../src/contacts-store.vala"
						_b_persona_it = _tmp21_;
#line 105 "../src/contacts-store.vala"
						while (TRUE) {
#line 976 "contacts-store.c"
							GeeIterator* _tmp22_;
							FolksPersona* b_persona = NULL;
							GeeIterator* _tmp23_;
							gpointer _tmp24_;
							FolksPersona* _tmp25_;
							const gchar* _tmp26_;
							const gchar* _tmp27_;
							const gchar* _tmp28_;
#line 105 "../src/contacts-store.vala"
							_tmp22_ = _b_persona_it;
#line 105 "../src/contacts-store.vala"
							if (!gee_iterator_next (_tmp22_)) {
#line 105 "../src/contacts-store.vala"
								break;
#line 991 "contacts-store.c"
							}
#line 105 "../src/contacts-store.vala"
							_tmp23_ = _b_persona_it;
#line 105 "../src/contacts-store.vala"
							_tmp24_ = gee_iterator_get (_tmp23_);
#line 105 "../src/contacts-store.vala"
							b_persona = (FolksPersona*) _tmp24_;
#line 106 "../src/contacts-store.vala"
							_tmp25_ = b_persona;
#line 106 "../src/contacts-store.vala"
							_tmp26_ = folks_persona_get_uid (_tmp25_);
#line 106 "../src/contacts-store.vala"
							_tmp27_ = _tmp26_;
#line 106 "../src/contacts-store.vala"
							_tmp28_ = no_link_uid;
#line 106 "../src/contacts-store.vala"
							if (g_strcmp0 (_tmp27_, _tmp28_) == 0) {
#line 107 "../src/contacts-store.vala"
								result = FALSE;
#line 107 "../src/contacts-store.vala"
								_g_object_unref0 (b_persona);
#line 107 "../src/contacts-store.vala"
								_g_object_unref0 (_b_persona_it);
#line 107 "../src/contacts-store.vala"
								_g_free0 (no_link_uid);
#line 107 "../src/contacts-store.vala"
								_g_object_unref0 (_no_link_uid_it);
#line 107 "../src/contacts-store.vala"
								_g_object_unref0 (a_persona);
#line 107 "../src/contacts-store.vala"
								_g_object_unref0 (_a_persona_it);
#line 107 "../src/contacts-store.vala"
								return result;
#line 1025 "contacts-store.c"
							}
#line 105 "../src/contacts-store.vala"
							_g_object_unref0 (b_persona);
#line 1029 "contacts-store.c"
						}
#line 105 "../src/contacts-store.vala"
						_g_object_unref0 (_b_persona_it);
#line 1033 "contacts-store.c"
					}
#line 104 "../src/contacts-store.vala"
					_g_free0 (no_link_uid);
#line 1037 "contacts-store.c"
				}
#line 104 "../src/contacts-store.vala"
				_g_object_unref0 (_no_link_uid_it);
#line 1041 "contacts-store.c"
			}
#line 103 "../src/contacts-store.vala"
			_g_object_unref0 (a_persona);
#line 1045 "contacts-store.c"
		}
#line 103 "../src/contacts-store.vala"
		_g_object_unref0 (_a_persona_it);
#line 1049 "contacts-store.c"
	}
	{
		GeeIterator* _b_persona_it = NULL;
		FolksIndividual* _tmp29_;
		GeeSet* _tmp30_;
		GeeSet* _tmp31_;
		GeeIterator* _tmp32_;
#line 111 "../src/contacts-store.vala"
		_tmp29_ = b->individual;
#line 111 "../src/contacts-store.vala"
		_tmp30_ = folks_individual_get_personas (_tmp29_);
#line 111 "../src/contacts-store.vala"
		_tmp31_ = _tmp30_;
#line 111 "../src/contacts-store.vala"
		_tmp32_ = gee_iterable_iterator ((GeeIterable*) _tmp31_);
#line 111 "../src/contacts-store.vala"
		_b_persona_it = _tmp32_;
#line 111 "../src/contacts-store.vala"
		while (TRUE) {
#line 1069 "contacts-store.c"
			GeeIterator* _tmp33_;
			FolksPersona* b_persona = NULL;
			GeeIterator* _tmp34_;
			gpointer _tmp35_;
#line 111 "../src/contacts-store.vala"
			_tmp33_ = _b_persona_it;
#line 111 "../src/contacts-store.vala"
			if (!gee_iterator_next (_tmp33_)) {
#line 111 "../src/contacts-store.vala"
				break;
#line 1080 "contacts-store.c"
			}
#line 111 "../src/contacts-store.vala"
			_tmp34_ = _b_persona_it;
#line 111 "../src/contacts-store.vala"
			_tmp35_ = gee_iterator_get (_tmp34_);
#line 111 "../src/contacts-store.vala"
			b_persona = (FolksPersona*) _tmp35_;
#line 1088 "contacts-store.c"
			{
				GeeIterator* _no_link_uid_it = NULL;
				GeeHashMultiMap* _tmp36_;
				FolksPersona* _tmp37_;
				const gchar* _tmp38_;
				const gchar* _tmp39_;
				GeeCollection* _tmp40_;
				GeeCollection* _tmp41_;
				GeeIterator* _tmp42_;
				GeeIterator* _tmp43_;
#line 112 "../src/contacts-store.vala"
				_tmp36_ = self->dont_suggest_link;
#line 112 "../src/contacts-store.vala"
				_tmp37_ = b_persona;
#line 112 "../src/contacts-store.vala"
				_tmp38_ = folks_persona_get_uid (_tmp37_);
#line 112 "../src/contacts-store.vala"
				_tmp39_ = _tmp38_;
#line 112 "../src/contacts-store.vala"
				_tmp40_ = gee_multi_map_get ((GeeMultiMap*) _tmp36_, _tmp39_);
#line 112 "../src/contacts-store.vala"
				_tmp41_ = _tmp40_;
#line 112 "../src/contacts-store.vala"
				_tmp42_ = gee_iterable_iterator ((GeeIterable*) _tmp41_);
#line 112 "../src/contacts-store.vala"
				_tmp43_ = _tmp42_;
#line 112 "../src/contacts-store.vala"
				_g_object_unref0 (_tmp41_);
#line 112 "../src/contacts-store.vala"
				_no_link_uid_it = _tmp43_;
#line 112 "../src/contacts-store.vala"
				while (TRUE) {
#line 1121 "contacts-store.c"
					GeeIterator* _tmp44_;
					gchar* no_link_uid = NULL;
					GeeIterator* _tmp45_;
					gpointer _tmp46_;
#line 112 "../src/contacts-store.vala"
					_tmp44_ = _no_link_uid_it;
#line 112 "../src/contacts-store.vala"
					if (!gee_iterator_next (_tmp44_)) {
#line 112 "../src/contacts-store.vala"
						break;
#line 1132 "contacts-store.c"
					}
#line 112 "../src/contacts-store.vala"
					_tmp45_ = _no_link_uid_it;
#line 112 "../src/contacts-store.vala"
					_tmp46_ = gee_iterator_get (_tmp45_);
#line 112 "../src/contacts-store.vala"
					no_link_uid = (gchar*) _tmp46_;
#line 1140 "contacts-store.c"
					{
						GeeIterator* _a_persona_it = NULL;
						FolksIndividual* _tmp47_;
						GeeSet* _tmp48_;
						GeeSet* _tmp49_;
						GeeIterator* _tmp50_;
#line 113 "../src/contacts-store.vala"
						_tmp47_ = a->individual;
#line 113 "../src/contacts-store.vala"
						_tmp48_ = folks_individual_get_personas (_tmp47_);
#line 113 "../src/contacts-store.vala"
						_tmp49_ = _tmp48_;
#line 113 "../src/contacts-store.vala"
						_tmp50_ = gee_iterable_iterator ((GeeIterable*) _tmp49_);
#line 113 "../src/contacts-store.vala"
						_a_persona_it = _tmp50_;
#line 113 "../src/contacts-store.vala"
						while (TRUE) {
#line 1159 "contacts-store.c"
							GeeIterator* _tmp51_;
							FolksPersona* a_persona = NULL;
							GeeIterator* _tmp52_;
							gpointer _tmp53_;
							FolksPersona* _tmp54_;
							const gchar* _tmp55_;
							const gchar* _tmp56_;
							const gchar* _tmp57_;
#line 113 "../src/contacts-store.vala"
							_tmp51_ = _a_persona_it;
#line 113 "../src/contacts-store.vala"
							if (!gee_iterator_next (_tmp51_)) {
#line 113 "../src/contacts-store.vala"
								break;
#line 1174 "contacts-store.c"
							}
#line 113 "../src/contacts-store.vala"
							_tmp52_ = _a_persona_it;
#line 113 "../src/contacts-store.vala"
							_tmp53_ = gee_iterator_get (_tmp52_);
#line 113 "../src/contacts-store.vala"
							a_persona = (FolksPersona*) _tmp53_;
#line 114 "../src/contacts-store.vala"
							_tmp54_ = a_persona;
#line 114 "../src/contacts-store.vala"
							_tmp55_ = folks_persona_get_uid (_tmp54_);
#line 114 "../src/contacts-store.vala"
							_tmp56_ = _tmp55_;
#line 114 "../src/contacts-store.vala"
							_tmp57_ = no_link_uid;
#line 114 "../src/contacts-store.vala"
							if (g_strcmp0 (_tmp56_, _tmp57_) == 0) {
#line 115 "../src/contacts-store.vala"
								result = FALSE;
#line 115 "../src/contacts-store.vala"
								_g_object_unref0 (a_persona);
#line 115 "../src/contacts-store.vala"
								_g_object_unref0 (_a_persona_it);
#line 115 "../src/contacts-store.vala"
								_g_free0 (no_link_uid);
#line 115 "../src/contacts-store.vala"
								_g_object_unref0 (_no_link_uid_it);
#line 115 "../src/contacts-store.vala"
								_g_object_unref0 (b_persona);
#line 115 "../src/contacts-store.vala"
								_g_object_unref0 (_b_persona_it);
#line 115 "../src/contacts-store.vala"
								return result;
#line 1208 "contacts-store.c"
							}
#line 113 "../src/contacts-store.vala"
							_g_object_unref0 (a_persona);
#line 1212 "contacts-store.c"
						}
#line 113 "../src/contacts-store.vala"
						_g_object_unref0 (_a_persona_it);
#line 1216 "contacts-store.c"
					}
#line 112 "../src/contacts-store.vala"
					_g_free0 (no_link_uid);
#line 1220 "contacts-store.c"
				}
#line 112 "../src/contacts-store.vala"
				_g_object_unref0 (_no_link_uid_it);
#line 1224 "contacts-store.c"
			}
#line 111 "../src/contacts-store.vala"
			_g_object_unref0 (b_persona);
#line 1228 "contacts-store.c"
		}
#line 111 "../src/contacts-store.vala"
		_g_object_unref0 (_b_persona_it);
#line 1232 "contacts-store.c"
	}
#line 119 "../src/contacts-store.vala"
	result = TRUE;
#line 119 "../src/contacts-store.vala"
	return result;
#line 1238 "contacts-store.c"
}

void
contacts_store_add_no_suggest_link (ContactsStore* self,
                                    ContactsContact* a,
                                    ContactsContact* b)
{
	FolksPersona* persona1 = NULL;
	GeeList* _tmp0_;
	GeeList* _tmp1_;
	gint _tmp2_ = 0;
	gpointer* _tmp3_;
	FolksPersona** _tmp4_;
	gint _tmp4__length1;
	FolksPersona* _tmp5_;
	FolksPersona* _tmp6_;
	FolksPersona* _tmp7_;
	FolksPersona* persona2 = NULL;
	GeeList* _tmp8_;
	GeeList* _tmp9_;
	gint _tmp10_ = 0;
	gpointer* _tmp11_;
	FolksPersona** _tmp12_;
	gint _tmp12__length1;
	FolksPersona* _tmp13_;
	FolksPersona* _tmp14_;
	FolksPersona* _tmp15_;
	GeeHashMultiMap* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
#line 122 "../src/contacts-store.vala"
	g_return_if_fail (self != NULL);
#line 122 "../src/contacts-store.vala"
	g_return_if_fail (a != NULL);
#line 122 "../src/contacts-store.vala"
	g_return_if_fail (b != NULL);
#line 123 "../src/contacts-store.vala"
	_tmp0_ = contacts_contact_get_personas_for_display (a);
#line 123 "../src/contacts-store.vala"
	_tmp1_ = _tmp0_;
#line 123 "../src/contacts-store.vala"
	_tmp3_ = gee_collection_to_array ((GeeCollection*) _tmp1_, &_tmp2_);
#line 123 "../src/contacts-store.vala"
	_tmp4_ = _tmp3_;
#line 123 "../src/contacts-store.vala"
	_tmp4__length1 = _tmp2_;
#line 123 "../src/contacts-store.vala"
	_tmp5_ = _tmp4_[0];
#line 123 "../src/contacts-store.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 123 "../src/contacts-store.vala"
	_tmp7_ = _tmp6_;
#line 123 "../src/contacts-store.vala"
	_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_object_unref), NULL);
#line 123 "../src/contacts-store.vala"
	_g_object_unref0 (_tmp1_);
#line 123 "../src/contacts-store.vala"
	persona1 = _tmp7_;
#line 124 "../src/contacts-store.vala"
	_tmp8_ = contacts_contact_get_personas_for_display (b);
#line 124 "../src/contacts-store.vala"
	_tmp9_ = _tmp8_;
#line 124 "../src/contacts-store.vala"
	_tmp11_ = gee_collection_to_array ((GeeCollection*) _tmp9_, &_tmp10_);
#line 124 "../src/contacts-store.vala"
	_tmp12_ = _tmp11_;
#line 124 "../src/contacts-store.vala"
	_tmp12__length1 = _tmp10_;
#line 124 "../src/contacts-store.vala"
	_tmp13_ = _tmp12_[0];
#line 124 "../src/contacts-store.vala"
	_tmp14_ = _g_object_ref0 (_tmp13_);
#line 124 "../src/contacts-store.vala"
	_tmp15_ = _tmp14_;
#line 124 "../src/contacts-store.vala"
	_tmp12_ = (_vala_array_free (_tmp12_, _tmp12__length1, (GDestroyNotify) g_object_unref), NULL);
#line 124 "../src/contacts-store.vala"
	_g_object_unref0 (_tmp9_);
#line 124 "../src/contacts-store.vala"
	persona2 = _tmp15_;
#line 125 "../src/contacts-store.vala"
	_tmp16_ = self->dont_suggest_link;
#line 125 "../src/contacts-store.vala"
	_tmp17_ = folks_persona_get_uid (persona1);
#line 125 "../src/contacts-store.vala"
	_tmp18_ = _tmp17_;
#line 125 "../src/contacts-store.vala"
	_tmp19_ = folks_persona_get_uid (persona2);
#line 125 "../src/contacts-store.vala"
	_tmp20_ = _tmp19_;
#line 125 "../src/contacts-store.vala"
	gee_multi_map_set ((GeeMultiMap*) _tmp16_, _tmp18_, _tmp20_);
#line 126 "../src/contacts-store.vala"
	contacts_store_write_dont_suggest_db (self);
#line 122 "../src/contacts-store.vala"
	_g_object_unref0 (persona2);
#line 122 "../src/contacts-store.vala"
	_g_object_unref0 (persona1);
#line 1339 "contacts-store.c"
}

static void
contacts_store_on_individuals_changed_detailed (ContactsStore* self,
                                                GeeMultiMap* changes)
{
	GeeHashMap* replaced_individuals = NULL;
	GeeHashMap* _tmp0_;
	GeeSet* old_individuals = NULL;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GeeCollection* _tmp5_;
	GeeCollection* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
#line 161 "../src/contacts-store.vala"
	g_return_if_fail (self != NULL);
#line 161 "../src/contacts-store.vala"
	g_return_if_fail (changes != NULL);
#line 164 "../src/contacts-store.vala"
	_tmp0_ = gee_hash_map_new (FOLKS_TYPE_INDIVIDUAL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, FOLKS_TYPE_INDIVIDUAL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 164 "../src/contacts-store.vala"
	replaced_individuals = _tmp0_;
#line 165 "../src/contacts-store.vala"
	_tmp1_ = gee_multi_map_get_keys (changes);
#line 165 "../src/contacts-store.vala"
	old_individuals = _tmp1_;
#line 167 "../src/contacts-store.vala"
	_tmp2_ = old_individuals;
#line 167 "../src/contacts-store.vala"
	_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 167 "../src/contacts-store.vala"
	_tmp4_ = _tmp3_;
#line 167 "../src/contacts-store.vala"
	_tmp5_ = gee_multi_map_get (changes, NULL);
#line 167 "../src/contacts-store.vala"
	_tmp6_ = _tmp5_;
#line 167 "../src/contacts-store.vala"
	_tmp7_ = gee_collection_get_size (_tmp6_);
#line 167 "../src/contacts-store.vala"
	_tmp8_ = _tmp7_;
#line 167 "../src/contacts-store.vala"
	g_debug ("contacts-store.vala:167: Individuals changed: %d old, %d new", _tmp4_ - 1, _tmp8_);
#line 167 "../src/contacts-store.vala"
	_g_object_unref0 (_tmp6_);
#line 1387 "contacts-store.c"
	{
		GeeIterator* _old_individual_it = NULL;
		GeeSet* _tmp9_;
		GeeIterator* _tmp10_;
#line 170 "../src/contacts-store.vala"
		_tmp9_ = old_individuals;
#line 170 "../src/contacts-store.vala"
		_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 170 "../src/contacts-store.vala"
		_old_individual_it = _tmp10_;
#line 170 "../src/contacts-store.vala"
		while (TRUE) {
#line 1400 "contacts-store.c"
			GeeIterator* _tmp11_;
			FolksIndividual* old_individual = NULL;
			GeeIterator* _tmp12_;
			gpointer _tmp13_;
			FolksIndividual* _tmp14_;
#line 170 "../src/contacts-store.vala"
			_tmp11_ = _old_individual_it;
#line 170 "../src/contacts-store.vala"
			if (!gee_iterator_next (_tmp11_)) {
#line 170 "../src/contacts-store.vala"
				break;
#line 1412 "contacts-store.c"
			}
#line 170 "../src/contacts-store.vala"
			_tmp12_ = _old_individual_it;
#line 170 "../src/contacts-store.vala"
			_tmp13_ = gee_iterator_get (_tmp12_);
#line 170 "../src/contacts-store.vala"
			old_individual = (FolksIndividual*) _tmp13_;
#line 171 "../src/contacts-store.vala"
			_tmp14_ = old_individual;
#line 171 "../src/contacts-store.vala"
			if (_tmp14_ == NULL) {
#line 172 "../src/contacts-store.vala"
				_g_object_unref0 (old_individual);
#line 172 "../src/contacts-store.vala"
				continue;
#line 1428 "contacts-store.c"
			}
			{
				GeeIterator* _new_individual_it = NULL;
				FolksIndividual* _tmp15_;
				GeeCollection* _tmp16_;
				GeeCollection* _tmp17_;
				GeeIterator* _tmp18_;
				GeeIterator* _tmp19_;
#line 173 "../src/contacts-store.vala"
				_tmp15_ = old_individual;
#line 173 "../src/contacts-store.vala"
				_tmp16_ = gee_multi_map_get (changes, _tmp15_);
#line 173 "../src/contacts-store.vala"
				_tmp17_ = _tmp16_;
#line 173 "../src/contacts-store.vala"
				_tmp18_ = gee_iterable_iterator ((GeeIterable*) _tmp17_);
#line 173 "../src/contacts-store.vala"
				_tmp19_ = _tmp18_;
#line 173 "../src/contacts-store.vala"
				_g_object_unref0 (_tmp17_);
#line 173 "../src/contacts-store.vala"
				_new_individual_it = _tmp19_;
#line 173 "../src/contacts-store.vala"
				while (TRUE) {
#line 1453 "contacts-store.c"
					GeeIterator* _tmp20_;
					FolksIndividual* new_individual = NULL;
					GeeIterator* _tmp21_;
					gpointer _tmp22_;
					FolksIndividual* _tmp23_;
					gboolean _tmp24_ = FALSE;
					GeeHashMap* _tmp25_;
					FolksIndividual* _tmp26_;
#line 173 "../src/contacts-store.vala"
					_tmp20_ = _new_individual_it;
#line 173 "../src/contacts-store.vala"
					if (!gee_iterator_next (_tmp20_)) {
#line 173 "../src/contacts-store.vala"
						break;
#line 1468 "contacts-store.c"
					}
#line 173 "../src/contacts-store.vala"
					_tmp21_ = _new_individual_it;
#line 173 "../src/contacts-store.vala"
					_tmp22_ = gee_iterator_get (_tmp21_);
#line 173 "../src/contacts-store.vala"
					new_individual = (FolksIndividual*) _tmp22_;
#line 174 "../src/contacts-store.vala"
					_tmp23_ = new_individual;
#line 174 "../src/contacts-store.vala"
					if (_tmp23_ == NULL) {
#line 175 "../src/contacts-store.vala"
						_g_object_unref0 (new_individual);
#line 175 "../src/contacts-store.vala"
						continue;
#line 1484 "contacts-store.c"
					}
#line 176 "../src/contacts-store.vala"
					_tmp25_ = replaced_individuals;
#line 176 "../src/contacts-store.vala"
					_tmp26_ = new_individual;
#line 176 "../src/contacts-store.vala"
					if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp25_, _tmp26_)) {
#line 176 "../src/contacts-store.vala"
						_tmp24_ = TRUE;
#line 1494 "contacts-store.c"
					} else {
						FolksIndividual* _tmp27_;
#line 177 "../src/contacts-store.vala"
						_tmp27_ = old_individual;
#line 177 "../src/contacts-store.vala"
						_tmp24_ = contacts_store_individual_should_replace_at_join (self, _tmp27_);
#line 1501 "contacts-store.c"
					}
#line 176 "../src/contacts-store.vala"
					if (_tmp24_) {
#line 1505 "contacts-store.c"
						GeeHashMap* _tmp28_;
						FolksIndividual* _tmp29_;
						FolksIndividual* _tmp30_;
#line 178 "../src/contacts-store.vala"
						_tmp28_ = replaced_individuals;
#line 178 "../src/contacts-store.vala"
						_tmp29_ = new_individual;
#line 178 "../src/contacts-store.vala"
						_tmp30_ = old_individual;
#line 178 "../src/contacts-store.vala"
						gee_abstract_map_set ((GeeAbstractMap*) _tmp28_, _tmp29_, _tmp30_);
#line 1517 "contacts-store.c"
					}
#line 173 "../src/contacts-store.vala"
					_g_object_unref0 (new_individual);
#line 1521 "contacts-store.c"
				}
#line 173 "../src/contacts-store.vala"
				_g_object_unref0 (_new_individual_it);
#line 1525 "contacts-store.c"
			}
#line 170 "../src/contacts-store.vala"
			_g_object_unref0 (old_individual);
#line 1529 "contacts-store.c"
		}
#line 170 "../src/contacts-store.vala"
		_g_object_unref0 (_old_individual_it);
#line 1533 "contacts-store.c"
	}
	{
		GeeIterator* _old_individual_it = NULL;
		GeeSet* _tmp31_;
		GeeIterator* _tmp32_;
#line 183 "../src/contacts-store.vala"
		_tmp31_ = old_individuals;
#line 183 "../src/contacts-store.vala"
		_tmp32_ = gee_iterable_iterator ((GeeIterable*) _tmp31_);
#line 183 "../src/contacts-store.vala"
		_old_individual_it = _tmp32_;
#line 183 "../src/contacts-store.vala"
		while (TRUE) {
#line 1547 "contacts-store.c"
			GeeIterator* _tmp33_;
			FolksIndividual* old_individual = NULL;
			GeeIterator* _tmp34_;
			gpointer _tmp35_;
			GeeHashSet* replacements = NULL;
			GeeHashSet* _tmp66_;
#line 183 "../src/contacts-store.vala"
			_tmp33_ = _old_individual_it;
#line 183 "../src/contacts-store.vala"
			if (!gee_iterator_next (_tmp33_)) {
#line 183 "../src/contacts-store.vala"
				break;
#line 1560 "contacts-store.c"
			}
#line 183 "../src/contacts-store.vala"
			_tmp34_ = _old_individual_it;
#line 183 "../src/contacts-store.vala"
			_tmp35_ = gee_iterator_get (_tmp34_);
#line 183 "../src/contacts-store.vala"
			old_individual = (FolksIndividual*) _tmp35_;
#line 184 "../src/contacts-store.vala"
			replacements = NULL;
#line 1570 "contacts-store.c"
			{
				GeeIterator* _new_individual_it = NULL;
				FolksIndividual* _tmp36_;
				GeeCollection* _tmp37_;
				GeeCollection* _tmp38_;
				GeeIterator* _tmp39_;
				GeeIterator* _tmp40_;
#line 185 "../src/contacts-store.vala"
				_tmp36_ = old_individual;
#line 185 "../src/contacts-store.vala"
				_tmp37_ = gee_multi_map_get (changes, _tmp36_);
#line 185 "../src/contacts-store.vala"
				_tmp38_ = _tmp37_;
#line 185 "../src/contacts-store.vala"
				_tmp39_ = gee_iterable_iterator ((GeeIterable*) _tmp38_);
#line 185 "../src/contacts-store.vala"
				_tmp40_ = _tmp39_;
#line 185 "../src/contacts-store.vala"
				_g_object_unref0 (_tmp38_);
#line 185 "../src/contacts-store.vala"
				_new_individual_it = _tmp40_;
#line 185 "../src/contacts-store.vala"
				while (TRUE) {
#line 1594 "contacts-store.c"
					GeeIterator* _tmp41_;
					FolksIndividual* new_individual = NULL;
					GeeIterator* _tmp42_;
					gpointer _tmp43_;
					gboolean _tmp44_ = FALSE;
					gboolean _tmp45_ = FALSE;
					FolksIndividual* _tmp46_;
#line 185 "../src/contacts-store.vala"
					_tmp41_ = _new_individual_it;
#line 185 "../src/contacts-store.vala"
					if (!gee_iterator_next (_tmp41_)) {
#line 185 "../src/contacts-store.vala"
						break;
#line 1608 "contacts-store.c"
					}
#line 185 "../src/contacts-store.vala"
					_tmp42_ = _new_individual_it;
#line 185 "../src/contacts-store.vala"
					_tmp43_ = gee_iterator_get (_tmp42_);
#line 185 "../src/contacts-store.vala"
					new_individual = (FolksIndividual*) _tmp43_;
#line 186 "../src/contacts-store.vala"
					_tmp46_ = old_individual;
#line 186 "../src/contacts-store.vala"
					if (_tmp46_ != NULL) {
#line 1620 "contacts-store.c"
						FolksIndividual* _tmp47_;
#line 186 "../src/contacts-store.vala"
						_tmp47_ = new_individual;
#line 186 "../src/contacts-store.vala"
						_tmp45_ = _tmp47_ != NULL;
#line 1626 "contacts-store.c"
					} else {
#line 186 "../src/contacts-store.vala"
						_tmp45_ = FALSE;
#line 1630 "contacts-store.c"
					}
#line 186 "../src/contacts-store.vala"
					if (_tmp45_) {
#line 1634 "contacts-store.c"
						GeeHashMap* _tmp48_;
						FolksIndividual* _tmp49_;
						gpointer _tmp50_;
						FolksIndividual* _tmp51_;
						FolksIndividual* _tmp52_;
#line 187 "../src/contacts-store.vala"
						_tmp48_ = replaced_individuals;
#line 187 "../src/contacts-store.vala"
						_tmp49_ = new_individual;
#line 187 "../src/contacts-store.vala"
						_tmp50_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp48_, _tmp49_);
#line 187 "../src/contacts-store.vala"
						_tmp51_ = (FolksIndividual*) _tmp50_;
#line 187 "../src/contacts-store.vala"
						_tmp52_ = old_individual;
#line 187 "../src/contacts-store.vala"
						_tmp44_ = _tmp51_ == _tmp52_;
#line 187 "../src/contacts-store.vala"
						_g_object_unref0 (_tmp51_);
#line 1654 "contacts-store.c"
					} else {
#line 186 "../src/contacts-store.vala"
						_tmp44_ = FALSE;
#line 1658 "contacts-store.c"
					}
#line 186 "../src/contacts-store.vala"
					if (_tmp44_) {
#line 1662 "contacts-store.c"
						GeeHashSet* _tmp53_;
						GeeHashSet* _tmp55_;
						FolksIndividual* _tmp56_;
#line 188 "../src/contacts-store.vala"
						_tmp53_ = replacements;
#line 188 "../src/contacts-store.vala"
						if (_tmp53_ == NULL) {
#line 1670 "contacts-store.c"
							GeeHashSet* _tmp54_;
#line 189 "../src/contacts-store.vala"
							_tmp54_ = gee_hash_set_new (FOLKS_TYPE_INDIVIDUAL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 189 "../src/contacts-store.vala"
							_g_object_unref0 (replacements);
#line 189 "../src/contacts-store.vala"
							replacements = _tmp54_;
#line 1678 "contacts-store.c"
						}
#line 190 "../src/contacts-store.vala"
						_tmp55_ = replacements;
#line 190 "../src/contacts-store.vala"
						_tmp56_ = new_individual;
#line 190 "../src/contacts-store.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp55_, _tmp56_);
#line 1686 "contacts-store.c"
					} else {
						FolksIndividual* _tmp57_;
#line 191 "../src/contacts-store.vala"
						_tmp57_ = old_individual;
#line 191 "../src/contacts-store.vala"
						if (_tmp57_ != NULL) {
#line 1693 "contacts-store.c"
							ContactsContact* c = NULL;
							FolksIndividual* _tmp58_;
							ContactsContact* _tmp59_;
							ContactsContact* _tmp60_;
							ContactsContact* _tmp61_;
#line 193 "../src/contacts-store.vala"
							_tmp58_ = old_individual;
#line 193 "../src/contacts-store.vala"
							_tmp59_ = contacts_contact_from_individual (_tmp58_);
#line 193 "../src/contacts-store.vala"
							_tmp60_ = _g_object_ref0 (_tmp59_);
#line 193 "../src/contacts-store.vala"
							c = _tmp60_;
#line 194 "../src/contacts-store.vala"
							_tmp61_ = c;
#line 194 "../src/contacts-store.vala"
							contacts_store_remove (self, _tmp61_);
#line 191 "../src/contacts-store.vala"
							_g_object_unref0 (c);
#line 1713 "contacts-store.c"
						} else {
							FolksIndividual* _tmp62_;
#line 195 "../src/contacts-store.vala"
							_tmp62_ = new_individual;
#line 195 "../src/contacts-store.vala"
							if (_tmp62_ != NULL) {
#line 1720 "contacts-store.c"
								FolksIndividual* _tmp63_;
								ContactsContact* _tmp64_;
								ContactsContact* _tmp65_;
#line 197 "../src/contacts-store.vala"
								_tmp63_ = new_individual;
#line 197 "../src/contacts-store.vala"
								_tmp64_ = contacts_contact_new (self, _tmp63_);
#line 197 "../src/contacts-store.vala"
								_tmp65_ = _tmp64_;
#line 197 "../src/contacts-store.vala"
								contacts_store_add (self, _tmp65_);
#line 197 "../src/contacts-store.vala"
								_g_object_unref0 (_tmp65_);
#line 1734 "contacts-store.c"
							}
						}
					}
#line 185 "../src/contacts-store.vala"
					_g_object_unref0 (new_individual);
#line 1740 "contacts-store.c"
				}
#line 185 "../src/contacts-store.vala"
				_g_object_unref0 (_new_individual_it);
#line 1744 "contacts-store.c"
			}
#line 206 "../src/contacts-store.vala"
			_tmp66_ = replacements;
#line 206 "../src/contacts-store.vala"
			if (_tmp66_ != NULL) {
#line 1750 "contacts-store.c"
				FolksIndividual* main_individual = NULL;
				ContactsContact* c = NULL;
				FolksIndividual* _tmp75_;
				ContactsContact* _tmp76_;
				ContactsContact* _tmp77_;
				ContactsContact* _tmp78_;
				FolksIndividual* _tmp79_;
#line 207 "../src/contacts-store.vala"
				main_individual = NULL;
#line 1760 "contacts-store.c"
				{
					GeeIterator* _i_it = NULL;
					GeeHashSet* _tmp67_;
					GeeIterator* _tmp68_;
#line 208 "../src/contacts-store.vala"
					_tmp67_ = replacements;
#line 208 "../src/contacts-store.vala"
					_tmp68_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp67_);
#line 208 "../src/contacts-store.vala"
					_i_it = _tmp68_;
#line 208 "../src/contacts-store.vala"
					while (TRUE) {
#line 1773 "contacts-store.c"
						GeeIterator* _tmp69_;
						FolksIndividual* i = NULL;
						GeeIterator* _tmp70_;
						gpointer _tmp71_;
						FolksIndividual* _tmp72_;
						FolksIndividual* _tmp73_;
						FolksIndividual* _tmp74_;
#line 208 "../src/contacts-store.vala"
						_tmp69_ = _i_it;
#line 208 "../src/contacts-store.vala"
						if (!gee_iterator_next (_tmp69_)) {
#line 208 "../src/contacts-store.vala"
							break;
#line 1787 "contacts-store.c"
						}
#line 208 "../src/contacts-store.vala"
						_tmp70_ = _i_it;
#line 208 "../src/contacts-store.vala"
						_tmp71_ = gee_iterator_get (_tmp70_);
#line 208 "../src/contacts-store.vala"
						i = (FolksIndividual*) _tmp71_;
#line 209 "../src/contacts-store.vala"
						_tmp72_ = i;
#line 209 "../src/contacts-store.vala"
						_tmp73_ = _g_object_ref0 (_tmp72_);
#line 209 "../src/contacts-store.vala"
						_g_object_unref0 (main_individual);
#line 209 "../src/contacts-store.vala"
						main_individual = _tmp73_;
#line 214 "../src/contacts-store.vala"
						_tmp74_ = i;
#line 214 "../src/contacts-store.vala"
						if (contacts_store_individual_can_replace_at_split (self, _tmp74_)) {
#line 215 "../src/contacts-store.vala"
							_g_object_unref0 (i);
#line 215 "../src/contacts-store.vala"
							break;
#line 1811 "contacts-store.c"
						}
#line 208 "../src/contacts-store.vala"
						_g_object_unref0 (i);
#line 1815 "contacts-store.c"
					}
#line 208 "../src/contacts-store.vala"
					_g_object_unref0 (_i_it);
#line 1819 "contacts-store.c"
				}
#line 218 "../src/contacts-store.vala"
				_tmp75_ = old_individual;
#line 218 "../src/contacts-store.vala"
				_tmp76_ = contacts_contact_from_individual (_tmp75_);
#line 218 "../src/contacts-store.vala"
				_tmp77_ = _g_object_ref0 (_tmp76_);
#line 218 "../src/contacts-store.vala"
				c = _tmp77_;
#line 219 "../src/contacts-store.vala"
				_tmp78_ = c;
#line 219 "../src/contacts-store.vala"
				_tmp79_ = main_individual;
#line 219 "../src/contacts-store.vala"
				contacts_contact_replace_individual (_tmp78_, _tmp79_);
#line 1835 "contacts-store.c"
				{
					GeeIterator* _i_it = NULL;
					GeeHashSet* _tmp80_;
					GeeIterator* _tmp81_;
#line 220 "../src/contacts-store.vala"
					_tmp80_ = replacements;
#line 220 "../src/contacts-store.vala"
					_tmp81_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp80_);
#line 220 "../src/contacts-store.vala"
					_i_it = _tmp81_;
#line 220 "../src/contacts-store.vala"
					while (TRUE) {
#line 1848 "contacts-store.c"
						GeeIterator* _tmp82_;
						FolksIndividual* i = NULL;
						GeeIterator* _tmp83_;
						gpointer _tmp84_;
						FolksIndividual* _tmp85_;
						FolksIndividual* _tmp86_;
#line 220 "../src/contacts-store.vala"
						_tmp82_ = _i_it;
#line 220 "../src/contacts-store.vala"
						if (!gee_iterator_next (_tmp82_)) {
#line 220 "../src/contacts-store.vala"
							break;
#line 1861 "contacts-store.c"
						}
#line 220 "../src/contacts-store.vala"
						_tmp83_ = _i_it;
#line 220 "../src/contacts-store.vala"
						_tmp84_ = gee_iterator_get (_tmp83_);
#line 220 "../src/contacts-store.vala"
						i = (FolksIndividual*) _tmp84_;
#line 221 "../src/contacts-store.vala"
						_tmp85_ = i;
#line 221 "../src/contacts-store.vala"
						_tmp86_ = main_individual;
#line 221 "../src/contacts-store.vala"
						if (_tmp85_ != _tmp86_) {
#line 1875 "contacts-store.c"
							FolksIndividual* _tmp87_;
							ContactsContact* _tmp88_;
							ContactsContact* _tmp89_;
#line 224 "../src/contacts-store.vala"
							_tmp87_ = i;
#line 224 "../src/contacts-store.vala"
							_tmp88_ = contacts_contact_new (self, _tmp87_);
#line 224 "../src/contacts-store.vala"
							_tmp89_ = _tmp88_;
#line 224 "../src/contacts-store.vala"
							contacts_store_add (self, _tmp89_);
#line 224 "../src/contacts-store.vala"
							_g_object_unref0 (_tmp89_);
#line 1889 "contacts-store.c"
						}
#line 220 "../src/contacts-store.vala"
						_g_object_unref0 (i);
#line 1893 "contacts-store.c"
					}
#line 220 "../src/contacts-store.vala"
					_g_object_unref0 (_i_it);
#line 1897 "contacts-store.c"
				}
#line 206 "../src/contacts-store.vala"
				_g_object_unref0 (c);
#line 206 "../src/contacts-store.vala"
				_g_object_unref0 (main_individual);
#line 1903 "contacts-store.c"
			}
#line 183 "../src/contacts-store.vala"
			_g_object_unref0 (replacements);
#line 183 "../src/contacts-store.vala"
			_g_object_unref0 (old_individual);
#line 1909 "contacts-store.c"
		}
#line 183 "../src/contacts-store.vala"
		_g_object_unref0 (_old_individual_it);
#line 1913 "contacts-store.c"
	}
#line 161 "../src/contacts-store.vala"
	_g_object_unref0 (old_individuals);
#line 161 "../src/contacts-store.vala"
	_g_object_unref0 (replaced_individuals);
#line 1919 "contacts-store.c"
}

static void
contacts_store_find_contact_data_free (gpointer _data)
{
	ContactsStoreFindContactData* _data_;
	_data_ = _data;
#line 22 "../src/contacts-store.vala"
	_g_object_unref0 (_data_->result);
#line 22 "../src/contacts-store.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/contacts-store.vala"
	g_slice_free (ContactsStoreFindContactData, _data_);
#line 1933 "contacts-store.c"
}

void
contacts_store_find_contact (ContactsStore* self,
                             ContactsStoreContactMatcher matcher,
                             gpointer matcher_target,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_)
{
	ContactsStoreFindContactData* _data_;
	ContactsStore* _tmp0_;
#line 22 "../src/contacts-store.vala"
	_data_ = g_slice_new0 (ContactsStoreFindContactData);
#line 22 "../src/contacts-store.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../src/contacts-store.vala"
	g_task_set_task_data (_data_->_async_result, _data_, contacts_store_find_contact_data_free);
#line 22 "../src/contacts-store.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/contacts-store.vala"
	_data_->self = _tmp0_;
#line 22 "../src/contacts-store.vala"
	_data_->matcher = matcher;
#line 22 "../src/contacts-store.vala"
	_data_->matcher_target = matcher_target;
#line 22 "../src/contacts-store.vala"
	contacts_store_find_contact_co (_data_);
#line 1961 "contacts-store.c"
}

ContactsContact*
contacts_store_find_contact_finish (ContactsStore* self,
                                    GAsyncResult* _res_)
{
	ContactsContact* result;
	ContactsStoreFindContactData* _data_;
#line 22 "../src/contacts-store.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 22 "../src/contacts-store.vala"
	result = _data_->result;
#line 22 "../src/contacts-store.vala"
	_data_->result = NULL;
#line 22 "../src/contacts-store.vala"
	return result;
#line 1978 "contacts-store.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 232 "../src/contacts-store.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 232 "../src/contacts-store.vala"
	return _data2_;
#line 1988 "contacts-store.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 232 "../src/contacts-store.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1998 "contacts-store.c"
		ContactsStore* self;
#line 232 "../src/contacts-store.vala"
		self = _data2_->self;
#line 232 "../src/contacts-store.vala"
		(_data2_->callback_target_destroy_notify == NULL) ? NULL : (_data2_->callback_target_destroy_notify (_data2_->callback_target), NULL);
#line 232 "../src/contacts-store.vala"
		_data2_->callback = NULL;
#line 232 "../src/contacts-store.vala"
		_data2_->callback_target = NULL;
#line 232 "../src/contacts-store.vala"
		_data2_->callback_target_destroy_notify = NULL;
#line 232 "../src/contacts-store.vala"
		_g_object_unref0 (_data2_->matched);
#line 232 "../src/contacts-store.vala"
		_g_object_unref0 (self);
#line 232 "../src/contacts-store.vala"
		g_slice_free (Block2Data, _data2_);
#line 2016 "contacts-store.c"
	}
}

static gboolean
_contacts_store_find_contact_co_gsource_func (gpointer self)
{
	gboolean result;
	result = contacts_store_find_contact_co (self);
#line 242 "../src/contacts-store.vala"
	return result;
#line 2027 "contacts-store.c"
}

static void
__lambda5_ (Block2Data* _data2_,
            ContactsContact* c)
{
	ContactsStore* self;
#line 243 "../src/contacts-store.vala"
	self = _data2_->self;
#line 243 "../src/contacts-store.vala"
	g_return_if_fail (c != NULL);
#line 244 "../src/contacts-store.vala"
	if (_data2_->matcher (c, _data2_->matcher_target)) {
#line 2041 "contacts-store.c"
		ContactsContact* _tmp0_;
		GSourceFunc _tmp1_;
		gpointer _tmp1__target;
#line 245 "../src/contacts-store.vala"
		_tmp0_ = _g_object_ref0 (c);
#line 245 "../src/contacts-store.vala"
		_g_object_unref0 (_data2_->matched);
#line 245 "../src/contacts-store.vala"
		_data2_->matched = _tmp0_;
#line 246 "../src/contacts-store.vala"
		_tmp1_ = _data2_->callback;
#line 246 "../src/contacts-store.vala"
		_tmp1__target = _data2_->callback_target;
#line 246 "../src/contacts-store.vala"
		_tmp1_ (_tmp1__target);
#line 2057 "contacts-store.c"
	}
}

static void
___lambda5__contacts_store_added (ContactsStore* _sender,
                                  ContactsContact* c,
                                  gpointer self)
{
#line 243 "../src/contacts-store.vala"
	__lambda5_ (self, c);
#line 2068 "contacts-store.c"
}

static void
__lambda6_ (Block2Data* _data2_)
{
	ContactsStore* self;
	GSourceFunc _tmp0_;
	gpointer _tmp0__target;
#line 249 "../src/contacts-store.vala"
	self = _data2_->self;
#line 250 "../src/contacts-store.vala"
	_tmp0_ = _data2_->callback;
#line 250 "../src/contacts-store.vala"
	_tmp0__target = _data2_->callback_target;
#line 250 "../src/contacts-store.vala"
	_tmp0_ (_tmp0__target);
#line 2085 "contacts-store.c"
}

static void
___lambda6__contacts_store_quiescent (ContactsStore* _sender,
                                      gpointer self)
{
#line 249 "../src/contacts-store.vala"
	__lambda6_ (self);
#line 2094 "contacts-store.c"
}

static gboolean
contacts_store_find_contact_co (ContactsStoreFindContactData* _data_)
{
#line 232 "../src/contacts-store.vala"
	switch (_data_->_state_) {
#line 232 "../src/contacts-store.vala"
		case 0:
#line 2104 "contacts-store.c"
		goto _state_0;
#line 232 "../src/contacts-store.vala"
		case 1:
#line 2108 "contacts-store.c"
		goto _state_1;
		default:
#line 232 "../src/contacts-store.vala"
		g_assert_not_reached ();
#line 2113 "contacts-store.c"
	}
	_state_0:
#line 232 "../src/contacts-store.vala"
	_data_->_data2_ = g_slice_new0 (Block2Data);
#line 232 "../src/contacts-store.vala"
	_data_->_data2_->_ref_count_ = 1;
#line 232 "../src/contacts-store.vala"
	_data_->_data2_->self = g_object_ref (_data_->self);
#line 232 "../src/contacts-store.vala"
	_data_->_data2_->matcher = _data_->matcher;
#line 232 "../src/contacts-store.vala"
	_data_->_data2_->matcher_target = _data_->matcher_target;
#line 232 "../src/contacts-store.vala"
	_data_->_data2_->_async_data_ = _data_;
#line 2128 "contacts-store.c"
	{
#line 233 "../src/contacts-store.vala"
		_data_->_tmp0_ = _data_->self->priv->contacts;
#line 233 "../src/contacts-store.vala"
		_data_->_tmp1_ = _g_object_ref0 (_data_->_tmp0_);
#line 233 "../src/contacts-store.vala"
		_data_->_c_list = _data_->_tmp1_;
#line 233 "../src/contacts-store.vala"
		_data_->_tmp2_ = _data_->_c_list;
#line 233 "../src/contacts-store.vala"
		_data_->_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp2_);
#line 233 "../src/contacts-store.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 233 "../src/contacts-store.vala"
		_data_->_c_size = _data_->_tmp4_;
#line 233 "../src/contacts-store.vala"
		_data_->_c_index = -1;
#line 233 "../src/contacts-store.vala"
		while (TRUE) {
#line 233 "../src/contacts-store.vala"
			_data_->_c_index = _data_->_c_index + 1;
#line 233 "../src/contacts-store.vala"
			if (!(_data_->_c_index < _data_->_c_size)) {
#line 233 "../src/contacts-store.vala"
				break;
#line 2154 "contacts-store.c"
			}
#line 233 "../src/contacts-store.vala"
			_data_->_tmp5_ = _data_->_c_list;
#line 233 "../src/contacts-store.vala"
			_data_->_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp5_, _data_->_c_index);
#line 233 "../src/contacts-store.vala"
			_data_->c = (ContactsContact*) _data_->_tmp6_;
#line 234 "../src/contacts-store.vala"
			_data_->_tmp7_ = _data_->c;
#line 234 "../src/contacts-store.vala"
			if (_data_->_data2_->matcher (_data_->_tmp7_, _data_->_data2_->matcher_target)) {
#line 235 "../src/contacts-store.vala"
				_data_->result = _data_->c;
#line 235 "../src/contacts-store.vala"
				_g_object_unref0 (_data_->_c_list);
#line 235 "../src/contacts-store.vala"
				block2_data_unref (_data_->_data2_);
#line 235 "../src/contacts-store.vala"
				_data_->_data2_ = NULL;
#line 235 "../src/contacts-store.vala"
				g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 235 "../src/contacts-store.vala"
				if (_data_->_state_ != 0) {
#line 235 "../src/contacts-store.vala"
					while (!g_task_get_completed (_data_->_async_result)) {
#line 235 "../src/contacts-store.vala"
						g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2182 "contacts-store.c"
					}
				}
#line 235 "../src/contacts-store.vala"
				g_object_unref (_data_->_async_result);
#line 235 "../src/contacts-store.vala"
				return FALSE;
#line 2189 "contacts-store.c"
			}
#line 233 "../src/contacts-store.vala"
			_g_object_unref0 (_data_->c);
#line 2193 "contacts-store.c"
		}
#line 233 "../src/contacts-store.vala"
		_g_object_unref0 (_data_->_c_list);
#line 2197 "contacts-store.c"
	}
#line 237 "../src/contacts-store.vala"
	_data_->_tmp8_ = contacts_store_get_is_quiescent (_data_->self);
#line 237 "../src/contacts-store.vala"
	_data_->_tmp9_ = _data_->_tmp8_;
#line 237 "../src/contacts-store.vala"
	if (_data_->_tmp9_) {
#line 238 "../src/contacts-store.vala"
		_data_->result = NULL;
#line 238 "../src/contacts-store.vala"
		block2_data_unref (_data_->_data2_);
#line 238 "../src/contacts-store.vala"
		_data_->_data2_ = NULL;
#line 238 "../src/contacts-store.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 238 "../src/contacts-store.vala"
		if (_data_->_state_ != 0) {
#line 238 "../src/contacts-store.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 238 "../src/contacts-store.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2219 "contacts-store.c"
			}
		}
#line 238 "../src/contacts-store.vala"
		g_object_unref (_data_->_async_result);
#line 238 "../src/contacts-store.vala"
		return FALSE;
#line 2226 "contacts-store.c"
	}
#line 240 "../src/contacts-store.vala"
	_data_->_data2_->matched = NULL;
#line 242 "../src/contacts-store.vala"
	_data_->_data2_->callback = _contacts_store_find_contact_co_gsource_func;
#line 242 "../src/contacts-store.vala"
	_data_->_data2_->callback_target = _data_;
#line 242 "../src/contacts-store.vala"
	_data_->_data2_->callback_target_destroy_notify = NULL;
#line 243 "../src/contacts-store.vala"
	_data_->_tmp10_ = g_signal_connect_data (_data_->self, "added", (GCallback) ___lambda5__contacts_store_added, block2_data_ref (_data_->_data2_), (GClosureNotify) block2_data_unref, 0);
#line 243 "../src/contacts-store.vala"
	_data_->id2 = _data_->_tmp10_;
#line 249 "../src/contacts-store.vala"
	_data_->_tmp11_ = g_signal_connect_data (_data_->self, "quiescent", (GCallback) ___lambda6__contacts_store_quiescent, block2_data_ref (_data_->_data2_), (GClosureNotify) block2_data_unref, 0);
#line 249 "../src/contacts-store.vala"
	_data_->id3 = _data_->_tmp11_;
#line 252 "../src/contacts-store.vala"
	_data_->_state_ = 1;
#line 252 "../src/contacts-store.vala"
	return FALSE;
#line 2248 "contacts-store.c"
	_state_1:
	;
#line 253 "../src/contacts-store.vala"
	g_signal_handler_disconnect ((GObject*) _data_->self, _data_->id2);
#line 254 "../src/contacts-store.vala"
	g_signal_handler_disconnect ((GObject*) _data_->self, _data_->id3);
#line 255 "../src/contacts-store.vala"
	_data_->_tmp12_ = _data_->_data2_->matched;
#line 255 "../src/contacts-store.vala"
	_data_->_tmp13_ = _g_object_ref0 (_data_->_tmp12_);
#line 255 "../src/contacts-store.vala"
	_data_->result = _data_->_tmp13_;
#line 255 "../src/contacts-store.vala"
	block2_data_unref (_data_->_data2_);
#line 255 "../src/contacts-store.vala"
	_data_->_data2_ = NULL;
#line 255 "../src/contacts-store.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 255 "../src/contacts-store.vala"
	if (_data_->_state_ != 0) {
#line 255 "../src/contacts-store.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 255 "../src/contacts-store.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2273 "contacts-store.c"
		}
	}
#line 255 "../src/contacts-store.vala"
	g_object_unref (_data_->_async_result);
#line 255 "../src/contacts-store.vala"
	return FALSE;
#line 2280 "contacts-store.c"
}

ContactsContact*
contacts_store_find_contact_with_persona (ContactsStore* self,
                                          FolksPersona* persona)
{
	ContactsContact* result = NULL;
#line 258 "../src/contacts-store.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 258 "../src/contacts-store.vala"
	g_return_val_if_fail (persona != NULL, NULL);
#line 2292 "contacts-store.c"
	{
		GeeArrayList* _contact_list = NULL;
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _contact_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _contact_index = 0;
#line 259 "../src/contacts-store.vala"
		_tmp0_ = self->priv->contacts;
#line 259 "../src/contacts-store.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 259 "../src/contacts-store.vala"
		_contact_list = _tmp1_;
#line 259 "../src/contacts-store.vala"
		_tmp2_ = _contact_list;
#line 259 "../src/contacts-store.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 259 "../src/contacts-store.vala"
		_tmp4_ = _tmp3_;
#line 259 "../src/contacts-store.vala"
		_contact_size = _tmp4_;
#line 259 "../src/contacts-store.vala"
		_contact_index = -1;
#line 259 "../src/contacts-store.vala"
		while (TRUE) {
#line 2320 "contacts-store.c"
			ContactsContact* contact = NULL;
			GeeArrayList* _tmp5_;
			gpointer _tmp6_;
			ContactsContact* _tmp7_;
			FolksIndividual* _tmp8_;
			GeeSet* _tmp9_;
			GeeSet* _tmp10_;
#line 259 "../src/contacts-store.vala"
			_contact_index = _contact_index + 1;
#line 259 "../src/contacts-store.vala"
			if (!(_contact_index < _contact_size)) {
#line 259 "../src/contacts-store.vala"
				break;
#line 2334 "contacts-store.c"
			}
#line 259 "../src/contacts-store.vala"
			_tmp5_ = _contact_list;
#line 259 "../src/contacts-store.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _contact_index);
#line 259 "../src/contacts-store.vala"
			contact = (ContactsContact*) _tmp6_;
#line 260 "../src/contacts-store.vala"
			_tmp7_ = contact;
#line 260 "../src/contacts-store.vala"
			_tmp8_ = _tmp7_->individual;
#line 260 "../src/contacts-store.vala"
			_tmp9_ = folks_individual_get_personas (_tmp8_);
#line 260 "../src/contacts-store.vala"
			_tmp10_ = _tmp9_;
#line 260 "../src/contacts-store.vala"
			if (gee_collection_contains ((GeeCollection*) _tmp10_, persona)) {
#line 261 "../src/contacts-store.vala"
				result = contact;
#line 261 "../src/contacts-store.vala"
				_g_object_unref0 (_contact_list);
#line 261 "../src/contacts-store.vala"
				return result;
#line 2358 "contacts-store.c"
			}
#line 259 "../src/contacts-store.vala"
			_g_object_unref0 (contact);
#line 2362 "contacts-store.c"
		}
#line 259 "../src/contacts-store.vala"
		_g_object_unref0 (_contact_list);
#line 2366 "contacts-store.c"
	}
#line 263 "../src/contacts-store.vala"
	result = NULL;
#line 263 "../src/contacts-store.vala"
	return result;
#line 2372 "contacts-store.c"
}

GeeCollection*
contacts_store_get_contacts (ContactsStore* self)
{
	GeeCollection* result = NULL;
	GeeArrayList* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
#line 266 "../src/contacts-store.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 267 "../src/contacts-store.vala"
	_tmp0_ = self->priv->contacts;
#line 267 "../src/contacts-store.vala"
	_tmp1_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _tmp0_);
#line 267 "../src/contacts-store.vala"
	_tmp2_ = _tmp1_;
#line 267 "../src/contacts-store.vala"
	result = (GeeCollection*) _tmp2_;
#line 267 "../src/contacts-store.vala"
	return result;
#line 2394 "contacts-store.c"
}

static void
contacts_store_add (ContactsStore* self,
                    ContactsContact* c)
{
	GeeArrayList* _tmp0_;
#line 270 "../src/contacts-store.vala"
	g_return_if_fail (self != NULL);
#line 270 "../src/contacts-store.vala"
	g_return_if_fail (c != NULL);
#line 271 "../src/contacts-store.vala"
	_tmp0_ = self->priv->contacts;
#line 271 "../src/contacts-store.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, c);
#line 272 "../src/contacts-store.vala"
	g_signal_emit (self, contacts_store_signals[CONTACTS_STORE_ADDED_SIGNAL], 0, c);
#line 2412 "contacts-store.c"
}

static void
contacts_store_remove (ContactsStore* self,
                       ContactsContact* c)
{
	gint i = 0;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GeeArrayList* _tmp11_;
	GeeArrayList* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gpointer _tmp15_;
	ContactsContact* _tmp16_;
#line 275 "../src/contacts-store.vala"
	g_return_if_fail (self != NULL);
#line 275 "../src/contacts-store.vala"
	g_return_if_fail (c != NULL);
#line 276 "../src/contacts-store.vala"
	_tmp0_ = self->priv->contacts;
#line 276 "../src/contacts-store.vala"
	i = gee_abstract_list_index_of ((GeeAbstractList*) _tmp0_, c);
#line 277 "../src/contacts-store.vala"
	_tmp1_ = self->priv->contacts;
#line 277 "../src/contacts-store.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 277 "../src/contacts-store.vala"
	_tmp3_ = _tmp2_;
#line 277 "../src/contacts-store.vala"
	if (i != (_tmp3_ - 1)) {
#line 2446 "contacts-store.c"
		GeeArrayList* _tmp4_;
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gpointer _tmp9_;
		ContactsContact* _tmp10_;
#line 278 "../src/contacts-store.vala"
		_tmp4_ = self->priv->contacts;
#line 278 "../src/contacts-store.vala"
		_tmp5_ = self->priv->contacts;
#line 278 "../src/contacts-store.vala"
		_tmp6_ = self->priv->contacts;
#line 278 "../src/contacts-store.vala"
		_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 278 "../src/contacts-store.vala"
		_tmp8_ = _tmp7_;
#line 278 "../src/contacts-store.vala"
		_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _tmp8_ - 1);
#line 278 "../src/contacts-store.vala"
		_tmp10_ = (ContactsContact*) _tmp9_;
#line 278 "../src/contacts-store.vala"
		gee_abstract_list_set ((GeeAbstractList*) _tmp4_, i, _tmp10_);
#line 278 "../src/contacts-store.vala"
		_g_object_unref0 (_tmp10_);
#line 2472 "contacts-store.c"
	}
#line 279 "../src/contacts-store.vala"
	_tmp11_ = self->priv->contacts;
#line 279 "../src/contacts-store.vala"
	_tmp12_ = self->priv->contacts;
#line 279 "../src/contacts-store.vala"
	_tmp13_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp12_);
#line 279 "../src/contacts-store.vala"
	_tmp14_ = _tmp13_;
#line 279 "../src/contacts-store.vala"
	_tmp15_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp11_, _tmp14_ - 1);
#line 279 "../src/contacts-store.vala"
	_tmp16_ = (ContactsContact*) _tmp15_;
#line 279 "../src/contacts-store.vala"
	_g_object_unref0 (_tmp16_);
#line 281 "../src/contacts-store.vala"
	g_signal_emit (self, contacts_store_signals[CONTACTS_STORE_REMOVED_SIGNAL], 0, c);
#line 2490 "contacts-store.c"
}

ContactsStore*
contacts_store_construct (GType object_type)
{
	ContactsStore * self = NULL;
#line 22 "../src/contacts-store.vala"
	self = (ContactsStore*) g_object_new (object_type, NULL);
#line 22 "../src/contacts-store.vala"
	return self;
#line 2501 "contacts-store.c"
}

ContactsStore*
contacts_store_new (void)
{
#line 22 "../src/contacts-store.vala"
	return contacts_store_construct (CONTACTS_TYPE_STORE);
#line 2509 "contacts-store.c"
}

FolksIndividualAggregator*
contacts_store_get_aggregator (ContactsStore* self)
{
	FolksIndividualAggregator* result;
	FolksIndividualAggregator* _tmp0_;
#line 28 "../src/contacts-store.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/contacts-store.vala"
	_tmp0_ = self->priv->_aggregator;
#line 28 "../src/contacts-store.vala"
	result = _tmp0_;
#line 28 "../src/contacts-store.vala"
	return result;
#line 2525 "contacts-store.c"
}

static void
contacts_store_set_aggregator (ContactsStore* self,
                               FolksIndividualAggregator* value)
{
#line 28 "../src/contacts-store.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/contacts-store.vala"
	if (contacts_store_get_aggregator (self) != value) {
#line 2536 "contacts-store.c"
		FolksIndividualAggregator* _tmp0_;
#line 28 "../src/contacts-store.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 28 "../src/contacts-store.vala"
		_g_object_unref0 (self->priv->_aggregator);
#line 28 "../src/contacts-store.vala"
		self->priv->_aggregator = _tmp0_;
#line 28 "../src/contacts-store.vala"
		g_object_notify_by_pspec ((GObject *) self, contacts_store_properties[CONTACTS_STORE_AGGREGATOR_PROPERTY]);
#line 2546 "contacts-store.c"
	}
}

FolksBackendStore*
contacts_store_get_backend_store (ContactsStore* self)
{
	FolksBackendStore* result;
	FolksIndividualAggregator* _tmp0_;
	FolksBackendStore* _tmp1_;
	FolksBackendStore* _tmp2_;
#line 29 "../src/contacts-store.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../src/contacts-store.vala"
	_tmp0_ = self->priv->_aggregator;
#line 29 "../src/contacts-store.vala"
	_tmp1_ = folks_individual_aggregator_get_backend_store (_tmp0_);
#line 29 "../src/contacts-store.vala"
	_tmp2_ = _tmp1_;
#line 29 "../src/contacts-store.vala"
	result = _tmp2_;
#line 29 "../src/contacts-store.vala"
	return result;
#line 2569 "contacts-store.c"
}

gboolean
contacts_store_get_is_quiescent (ContactsStore* self)
{
	gboolean result;
	FolksIndividualAggregator* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 39 "../src/contacts-store.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 39 "../src/contacts-store.vala"
	_tmp0_ = self->priv->_aggregator;
#line 39 "../src/contacts-store.vala"
	_tmp1_ = folks_individual_aggregator_get_is_quiescent (_tmp0_);
#line 39 "../src/contacts-store.vala"
	_tmp2_ = _tmp1_;
#line 39 "../src/contacts-store.vala"
	result = _tmp2_;
#line 39 "../src/contacts-store.vala"
	return result;
#line 2591 "contacts-store.c"
}

gboolean
contacts_store_get_is_prepared (ContactsStore* self)
{
	gboolean result;
	FolksIndividualAggregator* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 43 "../src/contacts-store.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 43 "../src/contacts-store.vala"
	_tmp0_ = self->priv->_aggregator;
#line 43 "../src/contacts-store.vala"
	_tmp1_ = folks_individual_aggregator_get_is_prepared (_tmp0_);
#line 43 "../src/contacts-store.vala"
	_tmp2_ = _tmp1_;
#line 43 "../src/contacts-store.vala"
	result = _tmp2_;
#line 43 "../src/contacts-store.vala"
	return result;
#line 2613 "contacts-store.c"
}

static gboolean
__lambda8_ (ContactsStore* self)
{
	gboolean result = FALSE;
#line 141 "../src/contacts-store.vala"
	g_signal_emit (self, contacts_store_signals[CONTACTS_STORE_QUIESCENT_SIGNAL], 0);
#line 142 "../src/contacts-store.vala"
	result = FALSE;
#line 142 "../src/contacts-store.vala"
	return result;
#line 2626 "contacts-store.c"
}

static gboolean
___lambda8__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda8_ ((ContactsStore*) self);
#line 140 "../src/contacts-store.vala"
	return result;
#line 2636 "contacts-store.c"
}

static void
_contacts_store___lambda7_ (ContactsStore* self,
                            GObject* obj,
                            GParamSpec* pspec)
{
#line 138 "../src/contacts-store.vala"
	g_return_if_fail (obj != NULL);
#line 138 "../src/contacts-store.vala"
	g_return_if_fail (pspec != NULL);
#line 140 "../src/contacts-store.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda8__gsource_func, g_object_ref (self), g_object_unref);
#line 2650 "contacts-store.c"
}

static void
__contacts_store___lambda7__g_object_notify (GObject* _sender,
                                             GParamSpec* pspec,
                                             gpointer self)
{
#line 138 "../src/contacts-store.vala"
	_contacts_store___lambda7_ ((ContactsStore*) self, _sender, pspec);
#line 2660 "contacts-store.c"
}

static gboolean
__lambda10_ (ContactsStore* self)
{
	gboolean result = FALSE;
#line 148 "../src/contacts-store.vala"
	g_signal_emit (self, contacts_store_signals[CONTACTS_STORE_PREPARED_SIGNAL], 0);
#line 149 "../src/contacts-store.vala"
	result = FALSE;
#line 149 "../src/contacts-store.vala"
	return result;
#line 2673 "contacts-store.c"
}

static gboolean
___lambda10__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda10_ ((ContactsStore*) self);
#line 147 "../src/contacts-store.vala"
	return result;
#line 2683 "contacts-store.c"
}

static void
_contacts_store___lambda9_ (ContactsStore* self,
                            GObject* obj,
                            GParamSpec* pspec)
{
#line 146 "../src/contacts-store.vala"
	g_return_if_fail (obj != NULL);
#line 146 "../src/contacts-store.vala"
	g_return_if_fail (pspec != NULL);
#line 147 "../src/contacts-store.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda10__gsource_func, g_object_ref (self), g_object_unref);
#line 2697 "contacts-store.c"
}

static void
__contacts_store___lambda9__g_object_notify (GObject* _sender,
                                             GParamSpec* pspec,
                                             gpointer self)
{
#line 146 "../src/contacts-store.vala"
	_contacts_store___lambda9_ ((ContactsStore*) self, _sender, pspec);
#line 2707 "contacts-store.c"
}

static void
_contacts_store_on_individuals_changed_detailed_folks_individual_aggregator_individuals_changed_detailed (FolksIndividualAggregator* _sender,
                                                                                                          GeeMultiMap* changes,
                                                                                                          gpointer self)
{
#line 153 "../src/contacts-store.vala"
	contacts_store_on_individuals_changed_detailed ((ContactsStore*) self, changes);
#line 2717 "contacts-store.c"
}

static GObject *
contacts_store_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ContactsStore * self;
	GeeArrayList* _tmp0_;
	GeeHashMultiMap* _tmp1_;
	FolksBackendStore* backend_store = NULL;
	FolksBackendStore* _tmp2_;
	FolksBackendStore* _tmp3_;
	FolksIndividualAggregator* _tmp4_;
	FolksIndividualAggregator* _tmp5_;
	FolksIndividualAggregator* _tmp6_;
	FolksIndividualAggregator* _tmp7_;
	FolksIndividualAggregator* _tmp8_;
	FolksIndividualAggregator* _tmp9_;
#line 129 "../src/contacts-store.vala"
	parent_class = G_OBJECT_CLASS (contacts_store_parent_class);
#line 129 "../src/contacts-store.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 129 "../src/contacts-store.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONTACTS_TYPE_STORE, ContactsStore);
#line 130 "../src/contacts-store.vala"
	_tmp0_ = gee_array_list_new (CONTACTS_TYPE_CONTACT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 130 "../src/contacts-store.vala"
	_g_object_unref0 (self->priv->contacts);
#line 130 "../src/contacts-store.vala"
	self->priv->contacts = _tmp0_;
#line 132 "../src/contacts-store.vala"
	_tmp1_ = gee_hash_multi_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 132 "../src/contacts-store.vala"
	_g_object_unref0 (self->dont_suggest_link);
#line 132 "../src/contacts-store.vala"
	self->dont_suggest_link = _tmp1_;
#line 133 "../src/contacts-store.vala"
	contacts_store_read_dont_suggest_db (self);
#line 135 "../src/contacts-store.vala"
	_tmp2_ = folks_backend_store_dup ();
#line 135 "../src/contacts-store.vala"
	backend_store = _tmp2_;
#line 137 "../src/contacts-store.vala"
	_tmp3_ = backend_store;
#line 137 "../src/contacts-store.vala"
	_tmp4_ = folks_individual_aggregator_dup_with_backend_store (_tmp3_);
#line 137 "../src/contacts-store.vala"
	_tmp5_ = _tmp4_;
#line 137 "../src/contacts-store.vala"
	contacts_store_set_aggregator (self, _tmp5_);
#line 137 "../src/contacts-store.vala"
	_g_object_unref0 (_tmp5_);
#line 138 "../src/contacts-store.vala"
	_tmp6_ = self->priv->_aggregator;
#line 138 "../src/contacts-store.vala"
	g_signal_connect_object ((GObject*) _tmp6_, "notify::is-quiescent", (GCallback) __contacts_store___lambda7__g_object_notify, self, 0);
#line 146 "../src/contacts-store.vala"
	_tmp7_ = self->priv->_aggregator;
#line 146 "../src/contacts-store.vala"
	g_signal_connect_object ((GObject*) _tmp7_, "notify::is-prepared", (GCallback) __contacts_store___lambda9__g_object_notify, self, 0);
#line 153 "../src/contacts-store.vala"
	_tmp8_ = self->priv->_aggregator;
#line 153 "../src/contacts-store.vala"
	g_signal_connect_object (_tmp8_, "individuals-changed-detailed", (GCallback) _contacts_store_on_individuals_changed_detailed_folks_individual_aggregator_individuals_changed_detailed, self, 0);
#line 154 "../src/contacts-store.vala"
	_tmp9_ = self->priv->_aggregator;
#line 154 "../src/contacts-store.vala"
	folks_individual_aggregator_prepare (_tmp9_, NULL, NULL);
#line 129 "../src/contacts-store.vala"
	_g_object_unref0 (backend_store);
#line 129 "../src/contacts-store.vala"
	return obj;
#line 2793 "contacts-store.c"
}

static void
contacts_store_class_init (ContactsStoreClass * klass,
                           gpointer klass_data)
{
#line 22 "../src/contacts-store.vala"
	contacts_store_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/contacts-store.vala"
	g_type_class_adjust_private_offset (klass, &ContactsStore_private_offset);
#line 22 "../src/contacts-store.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_contacts_store_get_property;
#line 22 "../src/contacts-store.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_contacts_store_set_property;
#line 22 "../src/contacts-store.vala"
	G_OBJECT_CLASS (klass)->constructor = contacts_store_constructor;
#line 22 "../src/contacts-store.vala"
	G_OBJECT_CLASS (klass)->finalize = contacts_store_finalize;
#line 22 "../src/contacts-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_STORE_AGGREGATOR_PROPERTY, contacts_store_properties[CONTACTS_STORE_AGGREGATOR_PROPERTY] = g_param_spec_object ("aggregator", "aggregator", "aggregator", FOLKS_TYPE_INDIVIDUAL_AGGREGATOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/contacts-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_STORE_BACKEND_STORE_PROPERTY, contacts_store_properties[CONTACTS_STORE_BACKEND_STORE_PROPERTY] = g_param_spec_object ("backend-store", "backend-store", "backend-store", FOLKS_TYPE_BACKEND_STORE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/contacts-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_STORE_IS_QUIESCENT_PROPERTY, contacts_store_properties[CONTACTS_STORE_IS_QUIESCENT_PROPERTY] = g_param_spec_boolean ("is-quiescent", "is-quiescent", "is-quiescent", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/contacts-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_STORE_IS_PREPARED_PROPERTY, contacts_store_properties[CONTACTS_STORE_IS_PREPARED_PROPERTY] = g_param_spec_boolean ("is-prepared", "is-prepared", "is-prepared", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/contacts-store.vala"
	contacts_store_signals[CONTACTS_STORE_ADDED_SIGNAL] = g_signal_new ("added", CONTACTS_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, CONTACTS_TYPE_CONTACT);
#line 22 "../src/contacts-store.vala"
	contacts_store_signals[CONTACTS_STORE_REMOVED_SIGNAL] = g_signal_new ("removed", CONTACTS_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, CONTACTS_TYPE_CONTACT);
#line 22 "../src/contacts-store.vala"
	contacts_store_signals[CONTACTS_STORE_QUIESCENT_SIGNAL] = g_signal_new ("quiescent", CONTACTS_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 22 "../src/contacts-store.vala"
	contacts_store_signals[CONTACTS_STORE_PREPARED_SIGNAL] = g_signal_new ("prepared", CONTACTS_TYPE_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2828 "contacts-store.c"
}

static void
contacts_store_instance_init (ContactsStore * self,
                              gpointer klass)
{
#line 22 "../src/contacts-store.vala"
	self->priv = contacts_store_get_instance_private (self);
#line 2837 "contacts-store.c"
}

static void
contacts_store_finalize (GObject * obj)
{
	ContactsStore * self;
#line 22 "../src/contacts-store.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONTACTS_TYPE_STORE, ContactsStore);
#line 28 "../src/contacts-store.vala"
	_g_object_unref0 (self->priv->_aggregator);
#line 30 "../src/contacts-store.vala"
	_g_object_unref0 (self->priv->contacts);
#line 32 "../src/contacts-store.vala"
	_g_object_unref0 (self->dont_suggest_link);
#line 22 "../src/contacts-store.vala"
	G_OBJECT_CLASS (contacts_store_parent_class)->finalize (obj);
#line 2854 "contacts-store.c"
}

GType
contacts_store_get_type (void)
{
	static volatile gsize contacts_store_type_id__volatile = 0;
	if (g_once_init_enter (&contacts_store_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ContactsStoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) contacts_store_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContactsStore), 0, (GInstanceInitFunc) contacts_store_instance_init, NULL };
		GType contacts_store_type_id;
		contacts_store_type_id = g_type_register_static (G_TYPE_OBJECT, "ContactsStore", &g_define_type_info, 0);
		ContactsStore_private_offset = g_type_add_instance_private (contacts_store_type_id, sizeof (ContactsStorePrivate));
		g_once_init_leave (&contacts_store_type_id__volatile, contacts_store_type_id);
	}
	return contacts_store_type_id__volatile;
}

static void
_vala_contacts_store_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	ContactsStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONTACTS_TYPE_STORE, ContactsStore);
#line 22 "../src/contacts-store.vala"
	switch (property_id) {
#line 22 "../src/contacts-store.vala"
		case CONTACTS_STORE_AGGREGATOR_PROPERTY:
#line 22 "../src/contacts-store.vala"
		g_value_set_object (value, contacts_store_get_aggregator (self));
#line 22 "../src/contacts-store.vala"
		break;
#line 22 "../src/contacts-store.vala"
		case CONTACTS_STORE_BACKEND_STORE_PROPERTY:
#line 22 "../src/contacts-store.vala"
		g_value_set_object (value, contacts_store_get_backend_store (self));
#line 22 "../src/contacts-store.vala"
		break;
#line 22 "../src/contacts-store.vala"
		case CONTACTS_STORE_IS_QUIESCENT_PROPERTY:
#line 22 "../src/contacts-store.vala"
		g_value_set_boolean (value, contacts_store_get_is_quiescent (self));
#line 22 "../src/contacts-store.vala"
		break;
#line 22 "../src/contacts-store.vala"
		case CONTACTS_STORE_IS_PREPARED_PROPERTY:
#line 22 "../src/contacts-store.vala"
		g_value_set_boolean (value, contacts_store_get_is_prepared (self));
#line 22 "../src/contacts-store.vala"
		break;
#line 2905 "contacts-store.c"
		default:
#line 22 "../src/contacts-store.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/contacts-store.vala"
		break;
#line 2911 "contacts-store.c"
	}
}

static void
_vala_contacts_store_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	ContactsStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONTACTS_TYPE_STORE, ContactsStore);
#line 22 "../src/contacts-store.vala"
	switch (property_id) {
#line 22 "../src/contacts-store.vala"
		case CONTACTS_STORE_AGGREGATOR_PROPERTY:
#line 22 "../src/contacts-store.vala"
		contacts_store_set_aggregator (self, g_value_get_object (value));
#line 22 "../src/contacts-store.vala"
		break;
#line 2931 "contacts-store.c"
		default:
#line 22 "../src/contacts-store.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/contacts-store.vala"
		break;
#line 2937 "contacts-store.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

