/* contacts-avatar.c generated by valac 0.44.0, the Vala compiler
 * generated from contacts-avatar.vala, do not modify */

/*
 * Copyright (C) 2011 Alexander Larsson <alexl@redhat.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include "contacts.h"
#include <gdk/gdk.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <folks/folks.h>
#include <string.h>

#define CONTACTS_TYPE_AVATAR (contacts_avatar_get_type ())
#define CONTACTS_AVATAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTACTS_TYPE_AVATAR, ContactsAvatar))
#define CONTACTS_AVATAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTACTS_TYPE_AVATAR, ContactsAvatarClass))
#define CONTACTS_IS_AVATAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTACTS_TYPE_AVATAR))
#define CONTACTS_IS_AVATAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTACTS_TYPE_AVATAR))
#define CONTACTS_AVATAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTACTS_TYPE_AVATAR, ContactsAvatarClass))

typedef struct _ContactsAvatar ContactsAvatar;
typedef struct _ContactsAvatarClass ContactsAvatarClass;
typedef struct _ContactsAvatarPrivate ContactsAvatarPrivate;
enum  {
	CONTACTS_AVATAR_0_PROPERTY,
	CONTACTS_AVATAR_NUM_PROPERTIES
};
static GParamSpec* contacts_avatar_properties[CONTACTS_AVATAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ContactsAvatarLoadAvatarData ContactsAvatarLoadAvatarData;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ContactsAvatar {
	GtkDrawingArea parent_instance;
	ContactsAvatarPrivate * priv;
};

struct _ContactsAvatarClass {
	GtkDrawingAreaClass parent_class;
};

struct _ContactsAvatarPrivate {
	gint size;
	GdkPixbuf* pixbuf;
	ContactsContact* contact;
	gboolean avatar_loaded;
	GdkRGBA* bg_color;
};

struct _ContactsAvatarLoadAvatarData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ContactsAvatar* self;
	ContactsContact* _tmp0_;
	GInputStream* stream;
	ContactsContact* _tmp1_;
	FolksIndividual* _tmp2_;
	GLoadableIcon* _tmp3_;
	GLoadableIcon* _tmp4_;
	GInputStream* _tmp5_;
	GdkPixbuf* _tmp6_;
	GInputStream* _tmp7_;
	GdkPixbuf* _tmp8_;
	GdkPixbuf* _tmp9_;
	GError* e;
	ContactsContact* _tmp10_;
	FolksIndividual* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	GError* _tmp14_;
	const gchar* _tmp15_;
	GError* _inner_error0_;
};

static gint ContactsAvatar_private_offset;
static gpointer contacts_avatar_parent_class = NULL;

GType contacts_avatar_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ContactsAvatar, g_object_unref)
ContactsAvatar* contacts_avatar_new (gint size,
                                     ContactsContact* contact);
ContactsAvatar* contacts_avatar_construct (GType object_type,
                                           gint size,
                                           ContactsContact* contact);
static void ___lambda5_ (ContactsAvatar* self,
                  GObject* s,
                  GParamSpec* p);
static void contacts_avatar_load_avatar (ContactsAvatar* self,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_);
static void contacts_avatar_load_avatar_finish (ContactsAvatar* self,
                                         GAsyncResult* _res_);
static void ____lambda5__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
void contacts_avatar_set_pixbuf (ContactsAvatar* self,
                                 GdkPixbuf* a_pixbuf);
static void contacts_avatar_load_avatar_data_free (gpointer _data);
static gboolean contacts_avatar_load_avatar_co (ContactsAvatarLoadAvatarData* _data_);
static void contacts_avatar_load_avatar_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_);
static gboolean contacts_avatar_real_draw (GtkWidget* base,
                                    cairo_t* cr);
static void contacts_avatar_draw_contact_avatar (ContactsAvatar* self,
                                          cairo_t* cr);
static void contacts_avatar_draw_fallback (ContactsAvatar* self,
                                    cairo_t* cr);
static void contacts_avatar_create_circle (ContactsAvatar* self,
                                    cairo_t* cr);
static void contacts_avatar_calculate_color (ContactsAvatar* self);
static GdkRGBA* _gdk_rgba_dup (GdkRGBA* self);
static void contacts_avatar_finalize (GObject * obj);

static const GdkRGBA CONTACTS_AVATAR_fg_color = {(gdouble) 0, (gdouble) 0, (gdouble) 0, 0.25};

static inline gpointer
contacts_avatar_get_instance_private (ContactsAvatar* self)
{
	return G_STRUCT_MEMBER_P (self, ContactsAvatar_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 41 "../src/contacts-avatar.vala"
	return self ? g_object_ref (self) : NULL;
#line 156 "contacts-avatar.c"
}

static void
___lambda5_ (ContactsAvatar* self,
             GObject* s,
             GParamSpec* p)
{
#line 43 "../src/contacts-avatar.vala"
	g_return_if_fail (s != NULL);
#line 43 "../src/contacts-avatar.vala"
	g_return_if_fail (p != NULL);
#line 44 "../src/contacts-avatar.vala"
	contacts_avatar_load_avatar (self, NULL, NULL);
#line 170 "contacts-avatar.c"
}

static void
____lambda5__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 43 "../src/contacts-avatar.vala"
	___lambda5_ ((ContactsAvatar*) self, _sender, pspec);
#line 180 "contacts-avatar.c"
}

ContactsAvatar*
contacts_avatar_construct (GType object_type,
                           gint size,
                           ContactsContact* contact)
{
	ContactsAvatar * self = NULL;
	ContactsContact* _tmp0_;
	gboolean _tmp2_ = FALSE;
#line 40 "../src/contacts-avatar.vala"
	self = (ContactsAvatar*) g_object_new (object_type, NULL);
#line 41 "../src/contacts-avatar.vala"
	_tmp0_ = _g_object_ref0 (contact);
#line 41 "../src/contacts-avatar.vala"
	_g_object_unref0 (self->priv->contact);
#line 41 "../src/contacts-avatar.vala"
	self->priv->contact = _tmp0_;
#line 42 "../src/contacts-avatar.vala"
	if (contact != NULL) {
#line 201 "contacts-avatar.c"
		FolksIndividual* _tmp1_;
#line 43 "../src/contacts-avatar.vala"
		_tmp1_ = contact->individual;
#line 43 "../src/contacts-avatar.vala"
		g_signal_connect_object ((GObject*) _tmp1_, "notify::avatar", (GCallback) ____lambda5__g_object_notify, self, 0);
#line 207 "contacts-avatar.c"
	}
#line 48 "../src/contacts-avatar.vala"
	self->priv->size = size;
#line 49 "../src/contacts-avatar.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, size, size);
#line 52 "../src/contacts-avatar.vala"
	if (contact == NULL) {
#line 52 "../src/contacts-avatar.vala"
		_tmp2_ = TRUE;
#line 217 "contacts-avatar.c"
	} else {
		FolksIndividual* _tmp3_;
		GLoadableIcon* _tmp4_;
		GLoadableIcon* _tmp5_;
#line 52 "../src/contacts-avatar.vala"
		_tmp3_ = contact->individual;
#line 52 "../src/contacts-avatar.vala"
		_tmp4_ = folks_avatar_details_get_avatar ((FolksAvatarDetails*) _tmp3_);
#line 52 "../src/contacts-avatar.vala"
		_tmp5_ = _tmp4_;
#line 52 "../src/contacts-avatar.vala"
		_tmp2_ = _tmp5_ == NULL;
#line 230 "contacts-avatar.c"
	}
#line 52 "../src/contacts-avatar.vala"
	self->priv->avatar_loaded = _tmp2_;
#line 54 "../src/contacts-avatar.vala"
	gtk_widget_show ((GtkWidget*) self);
#line 40 "../src/contacts-avatar.vala"
	return self;
#line 238 "contacts-avatar.c"
}

ContactsAvatar*
contacts_avatar_new (gint size,
                     ContactsContact* contact)
{
#line 40 "../src/contacts-avatar.vala"
	return contacts_avatar_construct (CONTACTS_TYPE_AVATAR, size, contact);
#line 247 "contacts-avatar.c"
}

/**
   * Manually set the avatar to the given pixbuf, even if the contact has an avatar.
   */
void
contacts_avatar_set_pixbuf (ContactsAvatar* self,
                            GdkPixbuf* a_pixbuf)
{
	GdkPixbuf* _tmp0_;
#line 60 "../src/contacts-avatar.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/contacts-avatar.vala"
	_tmp0_ = _g_object_ref0 (a_pixbuf);
#line 61 "../src/contacts-avatar.vala"
	_g_object_unref0 (self->priv->pixbuf);
#line 61 "../src/contacts-avatar.vala"
	self->priv->pixbuf = _tmp0_;
#line 62 "../src/contacts-avatar.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 268 "contacts-avatar.c"
}

static void
contacts_avatar_load_avatar_data_free (gpointer _data)
{
	ContactsAvatarLoadAvatarData* _data_;
	_data_ = _data;
#line 26 "../src/contacts-avatar.vala"
	_g_object_unref0 (_data_->self);
#line 26 "../src/contacts-avatar.vala"
	g_slice_free (ContactsAvatarLoadAvatarData, _data_);
#line 280 "contacts-avatar.c"
}

static void
contacts_avatar_load_avatar (ContactsAvatar* self,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_)
{
	ContactsAvatarLoadAvatarData* _data_;
	ContactsAvatar* _tmp0_;
#line 26 "../src/contacts-avatar.vala"
	_data_ = g_slice_new0 (ContactsAvatarLoadAvatarData);
#line 26 "../src/contacts-avatar.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 26 "../src/contacts-avatar.vala"
	g_task_set_task_data (_data_->_async_result, _data_, contacts_avatar_load_avatar_data_free);
#line 26 "../src/contacts-avatar.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 26 "../src/contacts-avatar.vala"
	_data_->self = _tmp0_;
#line 26 "../src/contacts-avatar.vala"
	contacts_avatar_load_avatar_co (_data_);
#line 302 "contacts-avatar.c"
}

static void
contacts_avatar_load_avatar_finish (ContactsAvatar* self,
                                    GAsyncResult* _res_)
{
	ContactsAvatarLoadAvatarData* _data_;
#line 26 "../src/contacts-avatar.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 312 "contacts-avatar.c"
}

static void
contacts_avatar_load_avatar_ready (GObject* source_object,
                                   GAsyncResult* _res_,
                                   gpointer _user_data_)
{
	ContactsAvatarLoadAvatarData* _data_;
#line 70 "../src/contacts-avatar.vala"
	_data_ = _user_data_;
#line 70 "../src/contacts-avatar.vala"
	_data_->_source_object_ = source_object;
#line 70 "../src/contacts-avatar.vala"
	_data_->_res_ = _res_;
#line 70 "../src/contacts-avatar.vala"
	contacts_avatar_load_avatar_co (_data_);
#line 329 "contacts-avatar.c"
}

static gboolean
contacts_avatar_load_avatar_co (ContactsAvatarLoadAvatarData* _data_)
{
#line 65 "../src/contacts-avatar.vala"
	switch (_data_->_state_) {
#line 65 "../src/contacts-avatar.vala"
		case 0:
#line 339 "contacts-avatar.c"
		goto _state_0;
#line 65 "../src/contacts-avatar.vala"
		case 1:
#line 343 "contacts-avatar.c"
		goto _state_1;
#line 65 "../src/contacts-avatar.vala"
		case 2:
#line 347 "contacts-avatar.c"
		goto _state_2;
		default:
#line 65 "../src/contacts-avatar.vala"
		g_assert_not_reached ();
#line 352 "contacts-avatar.c"
	}
	_state_0:
#line 66 "../src/contacts-avatar.vala"
	_data_->_tmp0_ = _data_->self->priv->contact;
#line 66 "../src/contacts-avatar.vala"
	_vala_assert (_data_->_tmp0_ != NULL, "this.contact != null");
#line 68 "../src/contacts-avatar.vala"
	_data_->self->priv->avatar_loaded = TRUE;
#line 361 "contacts-avatar.c"
	{
#line 70 "../src/contacts-avatar.vala"
		_data_->_tmp1_ = _data_->self->priv->contact;
#line 70 "../src/contacts-avatar.vala"
		_data_->_tmp2_ = _data_->_tmp1_->individual;
#line 70 "../src/contacts-avatar.vala"
		_data_->_tmp3_ = folks_avatar_details_get_avatar ((FolksAvatarDetails*) _data_->_tmp2_);
#line 70 "../src/contacts-avatar.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 70 "../src/contacts-avatar.vala"
		_data_->_state_ = 1;
#line 70 "../src/contacts-avatar.vala"
		g_loadable_icon_load_async (_data_->_tmp4_, _data_->self->priv->size, NULL, contacts_avatar_load_avatar_ready, _data_);
#line 70 "../src/contacts-avatar.vala"
		return FALSE;
#line 377 "contacts-avatar.c"
		_state_1:
#line 70 "../src/contacts-avatar.vala"
		_data_->_tmp5_ = g_loadable_icon_load_finish (_data_->_tmp4_, _data_->_res_, NULL, &_data_->_inner_error0_);
#line 70 "../src/contacts-avatar.vala"
		_data_->stream = _data_->_tmp5_;
#line 70 "../src/contacts-avatar.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 385 "contacts-avatar.c"
			goto __catch2_g_error;
		}
#line 71 "../src/contacts-avatar.vala"
		_data_->_tmp7_ = _data_->stream;
#line 71 "../src/contacts-avatar.vala"
		_data_->_state_ = 2;
#line 71 "../src/contacts-avatar.vala"
		gdk_pixbuf_new_from_stream_at_scale_async (_data_->_tmp7_, _data_->self->priv->size, _data_->self->priv->size, TRUE, NULL, contacts_avatar_load_avatar_ready, _data_);
#line 71 "../src/contacts-avatar.vala"
		return FALSE;
#line 396 "contacts-avatar.c"
		_state_2:
#line 71 "../src/contacts-avatar.vala"
		_data_->_tmp8_ = (GdkPixbuf*) gdk_pixbuf_new_from_stream_finish (_data_->_res_, &_data_->_inner_error0_);
#line 71 "../src/contacts-avatar.vala"
		_data_->_tmp6_ = _data_->_tmp8_;
#line 71 "../src/contacts-avatar.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 71 "../src/contacts-avatar.vala"
			_g_object_unref0 (_data_->stream);
#line 406 "contacts-avatar.c"
			goto __catch2_g_error;
		}
#line 71 "../src/contacts-avatar.vala"
		_data_->_tmp9_ = _data_->_tmp6_;
#line 71 "../src/contacts-avatar.vala"
		_data_->_tmp6_ = NULL;
#line 71 "../src/contacts-avatar.vala"
		_g_object_unref0 (_data_->self->priv->pixbuf);
#line 71 "../src/contacts-avatar.vala"
		_data_->self->priv->pixbuf = _data_->_tmp9_;
#line 72 "../src/contacts-avatar.vala"
		gtk_widget_queue_draw ((GtkWidget*) _data_->self);
#line 69 "../src/contacts-avatar.vala"
		_g_object_unref0 (_data_->_tmp6_);
#line 69 "../src/contacts-avatar.vala"
		_g_object_unref0 (_data_->stream);
#line 423 "contacts-avatar.c"
	}
	goto __finally2;
	__catch2_g_error:
	{
#line 69 "../src/contacts-avatar.vala"
		_data_->e = _data_->_inner_error0_;
#line 69 "../src/contacts-avatar.vala"
		_data_->_inner_error0_ = NULL;
#line 74 "../src/contacts-avatar.vala"
		_data_->_tmp10_ = _data_->self->priv->contact;
#line 74 "../src/contacts-avatar.vala"
		_data_->_tmp11_ = _data_->_tmp10_->individual;
#line 74 "../src/contacts-avatar.vala"
		_data_->_tmp12_ = folks_individual_get_display_name (_data_->_tmp11_);
#line 74 "../src/contacts-avatar.vala"
		_data_->_tmp13_ = _data_->_tmp12_;
#line 74 "../src/contacts-avatar.vala"
		_data_->_tmp14_ = _data_->e;
#line 74 "../src/contacts-avatar.vala"
		_data_->_tmp15_ = _data_->_tmp14_->message;
#line 74 "../src/contacts-avatar.vala"
		g_debug ("contacts-avatar.vala:74: Couldn't load avatar of contact %s. Reason: %" \
"s", _data_->_tmp13_, _data_->_tmp15_);
#line 69 "../src/contacts-avatar.vala"
		_g_error_free0 (_data_->e);
#line 448 "contacts-avatar.c"
	}
	__finally2:
#line 69 "../src/contacts-avatar.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 69 "../src/contacts-avatar.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 69 "../src/contacts-avatar.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 69 "../src/contacts-avatar.vala"
		g_object_unref (_data_->_async_result);
#line 69 "../src/contacts-avatar.vala"
		return FALSE;
#line 461 "contacts-avatar.c"
	}
#line 65 "../src/contacts-avatar.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 65 "../src/contacts-avatar.vala"
	if (_data_->_state_ != 0) {
#line 65 "../src/contacts-avatar.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 65 "../src/contacts-avatar.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 471 "contacts-avatar.c"
		}
	}
#line 65 "../src/contacts-avatar.vala"
	g_object_unref (_data_->_async_result);
#line 65 "../src/contacts-avatar.vala"
	return FALSE;
#line 478 "contacts-avatar.c"
}

static gboolean
contacts_avatar_real_draw (GtkWidget* base,
                           cairo_t* cr)
{
	ContactsAvatar * self;
	gboolean result = FALSE;
	GdkPixbuf* _tmp0_;
#line 78 "../src/contacts-avatar.vala"
	self = (ContactsAvatar*) base;
#line 78 "../src/contacts-avatar.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 80 "../src/contacts-avatar.vala"
	if (!self->priv->avatar_loaded) {
#line 81 "../src/contacts-avatar.vala"
		contacts_avatar_load_avatar (self, NULL, NULL);
#line 496 "contacts-avatar.c"
	}
#line 83 "../src/contacts-avatar.vala"
	_tmp0_ = self->priv->pixbuf;
#line 83 "../src/contacts-avatar.vala"
	if (_tmp0_ != NULL) {
#line 84 "../src/contacts-avatar.vala"
		contacts_avatar_draw_contact_avatar (self, cr);
#line 504 "contacts-avatar.c"
	} else {
#line 86 "../src/contacts-avatar.vala"
		contacts_avatar_draw_fallback (self, cr);
#line 508 "contacts-avatar.c"
	}
#line 88 "../src/contacts-avatar.vala"
	result = TRUE;
#line 88 "../src/contacts-avatar.vala"
	return result;
#line 514 "contacts-avatar.c"
}

static void
contacts_avatar_draw_contact_avatar (ContactsAvatar* self,
                                     cairo_t* cr)
{
	GdkPixbuf* _tmp0_;
#line 91 "../src/contacts-avatar.vala"
	g_return_if_fail (self != NULL);
#line 91 "../src/contacts-avatar.vala"
	g_return_if_fail (cr != NULL);
#line 92 "../src/contacts-avatar.vala"
	_tmp0_ = self->priv->pixbuf;
#line 92 "../src/contacts-avatar.vala"
	gdk_cairo_set_source_pixbuf (cr, _tmp0_, (gdouble) 0, (gdouble) 0);
#line 94 "../src/contacts-avatar.vala"
	contacts_avatar_create_circle (self, cr);
#line 95 "../src/contacts-avatar.vala"
	cairo_clip_preserve (cr);
#line 96 "../src/contacts-avatar.vala"
	cairo_paint (cr);
#line 536 "contacts-avatar.c"
}

static void
contacts_avatar_draw_fallback (ContactsAvatar* self,
                               cairo_t* cr)
{
	GdkRGBA* _tmp0_;
	GdkRGBA* _tmp1_;
	GdkRGBA* _tmp2_;
	GdkRGBA* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 99 "../src/contacts-avatar.vala"
	g_return_if_fail (self != NULL);
#line 99 "../src/contacts-avatar.vala"
	g_return_if_fail (cr != NULL);
#line 101 "../src/contacts-avatar.vala"
	_tmp0_ = self->priv->bg_color;
#line 101 "../src/contacts-avatar.vala"
	if (_tmp0_ == NULL) {
#line 102 "../src/contacts-avatar.vala"
		contacts_avatar_calculate_color (self);
#line 558 "contacts-avatar.c"
	}
#line 105 "../src/contacts-avatar.vala"
	_tmp1_ = self->priv->bg_color;
#line 105 "../src/contacts-avatar.vala"
	_tmp2_ = self->priv->bg_color;
#line 105 "../src/contacts-avatar.vala"
	_tmp3_ = self->priv->bg_color;
#line 105 "../src/contacts-avatar.vala"
	cairo_set_source_rgb (cr, (*_tmp1_).red, (*_tmp2_).green, (*_tmp3_).blue);
#line 106 "../src/contacts-avatar.vala"
	cairo_arc (cr, (gdouble) (self->priv->size / 2), (gdouble) (self->priv->size / 2), (gdouble) (self->priv->size / 2), (gdouble) 0, 2 * G_PI);
#line 107 "../src/contacts-avatar.vala"
	contacts_avatar_create_circle (self, cr);
#line 108 "../src/contacts-avatar.vala"
	cairo_fill_preserve (cr);
#line 574 "contacts-avatar.c"
	{
		GtkIconTheme* theme = NULL;
		GtkIconTheme* _tmp4_;
		GtkIconTheme* _tmp5_;
		GtkIconInfo* fallback_avatar = NULL;
		GtkIconInfo* _tmp6_;
		GdkPixbuf* icon_pixbuf = NULL;
		GdkPixbuf* _tmp7_;
#line 113 "../src/contacts-avatar.vala"
		_tmp4_ = gtk_icon_theme_get_default ();
#line 113 "../src/contacts-avatar.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 113 "../src/contacts-avatar.vala"
		theme = _tmp5_;
#line 114 "../src/contacts-avatar.vala"
		_tmp6_ = gtk_icon_theme_lookup_icon (theme, "avatar-default", (self->priv->size * 4) / 5, GTK_ICON_LOOKUP_FORCE_SYMBOLIC);
#line 114 "../src/contacts-avatar.vala"
		fallback_avatar = _tmp6_;
#line 117 "../src/contacts-avatar.vala"
		_tmp7_ = gtk_icon_info_load_symbolic (fallback_avatar, &CONTACTS_AVATAR_fg_color, NULL, NULL, NULL, NULL, &_inner_error0_);
#line 117 "../src/contacts-avatar.vala"
		icon_pixbuf = _tmp7_;
#line 117 "../src/contacts-avatar.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 117 "../src/contacts-avatar.vala"
			_g_object_unref0 (fallback_avatar);
#line 117 "../src/contacts-avatar.vala"
			_g_object_unref0 (theme);
#line 603 "contacts-avatar.c"
			goto __catch3_g_error;
		}
#line 118 "../src/contacts-avatar.vala"
		contacts_avatar_create_circle (self, cr);
#line 119 "../src/contacts-avatar.vala"
		cairo_clip_preserve (cr);
#line 120 "../src/contacts-avatar.vala"
		gdk_cairo_set_source_pixbuf (cr, icon_pixbuf, (gdouble) (1 + (self->priv->size / 10)), (gdouble) (1 + (self->priv->size / 5)));
#line 121 "../src/contacts-avatar.vala"
		cairo_paint (cr);
#line 111 "../src/contacts-avatar.vala"
		_g_object_unref0 (icon_pixbuf);
#line 111 "../src/contacts-avatar.vala"
		_g_object_unref0 (fallback_avatar);
#line 111 "../src/contacts-avatar.vala"
		_g_object_unref0 (theme);
#line 620 "contacts-avatar.c"
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 111 "../src/contacts-avatar.vala"
		e = _inner_error0_;
#line 111 "../src/contacts-avatar.vala"
		_inner_error0_ = NULL;
#line 123 "../src/contacts-avatar.vala"
		_tmp8_ = e;
#line 123 "../src/contacts-avatar.vala"
		_tmp9_ = _tmp8_->message;
#line 123 "../src/contacts-avatar.vala"
		g_warning ("contacts-avatar.vala:123: Couldn't get default avatar icon: %s", _tmp9_);
#line 111 "../src/contacts-avatar.vala"
		_g_error_free0 (e);
#line 640 "contacts-avatar.c"
	}
	__finally3:
#line 111 "../src/contacts-avatar.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 111 "../src/contacts-avatar.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 111 "../src/contacts-avatar.vala"
		g_clear_error (&_inner_error0_);
#line 111 "../src/contacts-avatar.vala"
		return;
#line 651 "contacts-avatar.c"
	}
}

static GdkRGBA*
_gdk_rgba_dup (GdkRGBA* self)
{
	GdkRGBA* dup;
#line 136 "../src/contacts-avatar.vala"
	dup = g_new0 (GdkRGBA, 1);
#line 136 "../src/contacts-avatar.vala"
	memcpy (dup, self, sizeof (GdkRGBA));
#line 136 "../src/contacts-avatar.vala"
	return dup;
#line 665 "contacts-avatar.c"
}

static gpointer
__gdk_rgba_dup0 (gpointer self)
{
#line 136 "../src/contacts-avatar.vala"
	return self ? _gdk_rgba_dup (self) : NULL;
#line 673 "contacts-avatar.c"
}

static void
contacts_avatar_calculate_color (ContactsAvatar* self)
{
	guint _tmp0_ = 0U;
	ContactsContact* _tmp1_;
	guint hash = 0U;
	gdouble r = 0.0;
	gdouble g = 0.0;
	gdouble b = 0.0;
	GdkRGBA _tmp7_ = {0};
	GdkRGBA* _tmp8_;
#line 127 "../src/contacts-avatar.vala"
	g_return_if_fail (self != NULL);
#line 129 "../src/contacts-avatar.vala"
	_tmp1_ = self->priv->contact;
#line 129 "../src/contacts-avatar.vala"
	if (_tmp1_ != NULL) {
#line 693 "contacts-avatar.c"
		GHashFunc _tmp2_;
		ContactsContact* _tmp3_;
		FolksIndividual* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 129 "../src/contacts-avatar.vala"
		_tmp2_ = g_str_hash;
#line 129 "../src/contacts-avatar.vala"
		_tmp3_ = self->priv->contact;
#line 129 "../src/contacts-avatar.vala"
		_tmp4_ = _tmp3_->individual;
#line 129 "../src/contacts-avatar.vala"
		_tmp5_ = folks_individual_get_id (_tmp4_);
#line 129 "../src/contacts-avatar.vala"
		_tmp6_ = _tmp5_;
#line 129 "../src/contacts-avatar.vala"
		_tmp0_ = _tmp2_ (_tmp6_);
#line 711 "contacts-avatar.c"
	} else {
#line 129 "../src/contacts-avatar.vala"
		_tmp0_ = (guint) GDK_CURRENT_TIME;
#line 715 "contacts-avatar.c"
	}
#line 129 "../src/contacts-avatar.vala"
	hash = _tmp0_;
#line 131 "../src/contacts-avatar.vala"
	r = ((hash & 0xFF0000) >> 16) / 255.0;
#line 132 "../src/contacts-avatar.vala"
	g = ((hash & 0x00FF00) >> 8) / 255.0;
#line 133 "../src/contacts-avatar.vala"
	b = (hash & 0x0000FF) / 255.0;
#line 136 "../src/contacts-avatar.vala"
	memset (&_tmp7_, 0, sizeof (GdkRGBA));
#line 136 "../src/contacts-avatar.vala"
	_tmp7_.red = (r + 2) / 3.0;
#line 136 "../src/contacts-avatar.vala"
	_tmp7_.green = (g + 2) / 3.0;
#line 136 "../src/contacts-avatar.vala"
	_tmp7_.blue = (b + 2) / 3.0;
#line 136 "../src/contacts-avatar.vala"
	_tmp7_.alpha = (gdouble) 0;
#line 136 "../src/contacts-avatar.vala"
	_tmp8_ = __gdk_rgba_dup0 (&_tmp7_);
#line 136 "../src/contacts-avatar.vala"
	_g_free0 (self->priv->bg_color);
#line 136 "../src/contacts-avatar.vala"
	self->priv->bg_color = _tmp8_;
#line 741 "contacts-avatar.c"
}

static void
contacts_avatar_create_circle (ContactsAvatar* self,
                               cairo_t* cr)
{
#line 144 "../src/contacts-avatar.vala"
	g_return_if_fail (self != NULL);
#line 144 "../src/contacts-avatar.vala"
	g_return_if_fail (cr != NULL);
#line 145 "../src/contacts-avatar.vala"
	cairo_arc (cr, (gdouble) (self->priv->size / 2), (gdouble) (self->priv->size / 2), (gdouble) (self->priv->size / 2), (gdouble) 0, 2 * G_PI);
#line 754 "contacts-avatar.c"
}

static void
contacts_avatar_class_init (ContactsAvatarClass * klass,
                            gpointer klass_data)
{
#line 26 "../src/contacts-avatar.vala"
	contacts_avatar_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/contacts-avatar.vala"
	g_type_class_adjust_private_offset (klass, &ContactsAvatar_private_offset);
#line 26 "../src/contacts-avatar.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) contacts_avatar_real_draw;
#line 26 "../src/contacts-avatar.vala"
	G_OBJECT_CLASS (klass)->finalize = contacts_avatar_finalize;
#line 769 "contacts-avatar.c"
}

static void
contacts_avatar_instance_init (ContactsAvatar * self,
                               gpointer klass)
{
#line 26 "../src/contacts-avatar.vala"
	self->priv = contacts_avatar_get_instance_private (self);
#line 28 "../src/contacts-avatar.vala"
	self->priv->pixbuf = NULL;
#line 30 "../src/contacts-avatar.vala"
	self->priv->contact = NULL;
#line 33 "../src/contacts-avatar.vala"
	self->priv->avatar_loaded = FALSE;
#line 36 "../src/contacts-avatar.vala"
	self->priv->bg_color = NULL;
#line 786 "contacts-avatar.c"
}

static void
contacts_avatar_finalize (GObject * obj)
{
	ContactsAvatar * self;
#line 26 "../src/contacts-avatar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONTACTS_TYPE_AVATAR, ContactsAvatar);
#line 28 "../src/contacts-avatar.vala"
	_g_object_unref0 (self->priv->pixbuf);
#line 30 "../src/contacts-avatar.vala"
	_g_object_unref0 (self->priv->contact);
#line 36 "../src/contacts-avatar.vala"
	_g_free0 (self->priv->bg_color);
#line 26 "../src/contacts-avatar.vala"
	G_OBJECT_CLASS (contacts_avatar_parent_class)->finalize (obj);
#line 803 "contacts-avatar.c"
}

/**
 * The Avatar of a Contact is responsible for showing an {@link Folks.Individual}'s
 * avatar, or a fallback if it's not available.
 */
GType
contacts_avatar_get_type (void)
{
	static volatile gsize contacts_avatar_type_id__volatile = 0;
	if (g_once_init_enter (&contacts_avatar_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ContactsAvatarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) contacts_avatar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContactsAvatar), 0, (GInstanceInitFunc) contacts_avatar_instance_init, NULL };
		GType contacts_avatar_type_id;
		contacts_avatar_type_id = g_type_register_static (gtk_drawing_area_get_type (), "ContactsAvatar", &g_define_type_info, 0);
		ContactsAvatar_private_offset = g_type_add_instance_private (contacts_avatar_type_id, sizeof (ContactsAvatarPrivate));
		g_once_init_leave (&contacts_avatar_type_id__volatile, contacts_avatar_type_id);
	}
	return contacts_avatar_type_id__volatile;
}

