/* contacts-in-app-notification.c generated by valac 0.44.0, the Vala compiler
 * generated from contacts-in-app-notification.vala, do not modify */

/*
 * Copyright (C) 2017 Niels De Graef <nielsdegraef@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#define CONTACTS_TYPE_IN_APP_NOTIFICATION (contacts_in_app_notification_get_type ())
#define CONTACTS_IN_APP_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTACTS_TYPE_IN_APP_NOTIFICATION, ContactsInAppNotification))
#define CONTACTS_IN_APP_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTACTS_TYPE_IN_APP_NOTIFICATION, ContactsInAppNotificationClass))
#define CONTACTS_IS_IN_APP_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTACTS_TYPE_IN_APP_NOTIFICATION))
#define CONTACTS_IS_IN_APP_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTACTS_TYPE_IN_APP_NOTIFICATION))
#define CONTACTS_IN_APP_NOTIFICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTACTS_TYPE_IN_APP_NOTIFICATION, ContactsInAppNotificationClass))

typedef struct _ContactsInAppNotification ContactsInAppNotification;
typedef struct _ContactsInAppNotificationClass ContactsInAppNotificationClass;
typedef struct _ContactsInAppNotificationPrivate ContactsInAppNotificationPrivate;
enum  {
	CONTACTS_IN_APP_NOTIFICATION_0_PROPERTY,
	CONTACTS_IN_APP_NOTIFICATION_MESSAGE_LABEL_PROPERTY,
	CONTACTS_IN_APP_NOTIFICATION_NUM_PROPERTIES
};
static GParamSpec* contacts_in_app_notification_properties[CONTACTS_IN_APP_NOTIFICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	CONTACTS_IN_APP_NOTIFICATION_DISMISSED_SIGNAL,
	CONTACTS_IN_APP_NOTIFICATION_NUM_SIGNALS
};
static guint contacts_in_app_notification_signals[CONTACTS_IN_APP_NOTIFICATION_NUM_SIGNALS] = {0};

struct _ContactsInAppNotification {
	GtkRevealer parent_instance;
	ContactsInAppNotificationPrivate * priv;
};

struct _ContactsInAppNotificationClass {
	GtkRevealerClass parent_class;
};

struct _ContactsInAppNotificationPrivate {
	GtkGrid* grid;
	GtkLabel* label;
};

static gint ContactsInAppNotification_private_offset;
static gpointer contacts_in_app_notification_parent_class = NULL;

GType contacts_in_app_notification_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ContactsInAppNotification, g_object_unref)
#define CONTACTS_IN_APP_NOTIFICATION_DEFAULT_KEEPALIVE ((guint) 5)
ContactsInAppNotification* contacts_in_app_notification_new (const gchar* message,
                                                             GtkButton* button);
ContactsInAppNotification* contacts_in_app_notification_construct (GType object_type,
                                                                   const gchar* message,
                                                                   GtkButton* button);
static void contacts_in_app_notification_on_child_revealed_changed (ContactsInAppNotification* self,
                                                             GObject* o,
                                                             GParamSpec* p);
static void _contacts_in_app_notification_on_child_revealed_changed_g_object_notify (GObject* _sender,
                                                                              GParamSpec* pspec,
                                                                              gpointer self);
void contacts_in_app_notification_show (ContactsInAppNotification* self);
static gboolean __lambda49_ (ContactsInAppNotification* self);
void contacts_in_app_notification_dismiss (ContactsInAppNotification* self);
static gboolean ___lambda49__gsource_func (gpointer self);
static void contacts_in_app_notification_on_close_button_clicked (ContactsInAppNotification* self,
                                                           GtkButton* close_button);
static void _contacts_in_app_notification_on_close_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                               gpointer self);
GtkLabel* contacts_in_app_notification_get_message_label (ContactsInAppNotification* self);
static void contacts_in_app_notification_finalize (GObject * obj);
static void _vala_contacts_in_app_notification_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);

static inline gpointer
contacts_in_app_notification_get_instance_private (ContactsInAppNotification* self)
{
	return G_STRUCT_MEMBER_P (self, ContactsInAppNotification_private_offset);
}

/**
   * Creates an in-app notification with the given message, and an accompanying button if not null.
   */
static void
_contacts_in_app_notification_on_child_revealed_changed_g_object_notify (GObject* _sender,
                                                                         GParamSpec* pspec,
                                                                         gpointer self)
{
#line 51 "../src/contacts-in-app-notification.vala"
	contacts_in_app_notification_on_child_revealed_changed ((ContactsInAppNotification*) self, _sender, pspec);
#line 113 "contacts-in-app-notification.c"
}

ContactsInAppNotification*
contacts_in_app_notification_construct (GType object_type,
                                        const gchar* message,
                                        GtkButton* button)
{
	ContactsInAppNotification * self = NULL;
	GtkLabel* _tmp0_;
#line 42 "../src/contacts-in-app-notification.vala"
	g_return_val_if_fail (message != NULL, NULL);
#line 42 "../src/contacts-in-app-notification.vala"
	self = (ContactsInAppNotification*) g_object_new (object_type, NULL);
#line 43 "../src/contacts-in-app-notification.vala"
	_tmp0_ = self->priv->label;
#line 43 "../src/contacts-in-app-notification.vala"
	gtk_label_set_label (_tmp0_, message);
#line 45 "../src/contacts-in-app-notification.vala"
	if (button != NULL) {
#line 133 "contacts-in-app-notification.c"
		GtkGrid* _tmp1_;
#line 46 "../src/contacts-in-app-notification.vala"
		gtk_widget_set_valign ((GtkWidget*) button, GTK_ALIGN_CENTER);
#line 47 "../src/contacts-in-app-notification.vala"
		_tmp1_ = self->priv->grid;
#line 47 "../src/contacts-in-app-notification.vala"
		gtk_grid_attach (_tmp1_, (GtkWidget*) button, 1, 0, 1, 1);
#line 48 "../src/contacts-in-app-notification.vala"
		gtk_widget_show ((GtkWidget*) button);
#line 143 "contacts-in-app-notification.c"
	}
#line 51 "../src/contacts-in-app-notification.vala"
	g_signal_connect_object ((GObject*) self, "notify::child-revealed", (GCallback) _contacts_in_app_notification_on_child_revealed_changed_g_object_notify, self, 0);
#line 42 "../src/contacts-in-app-notification.vala"
	return self;
#line 149 "contacts-in-app-notification.c"
}

ContactsInAppNotification*
contacts_in_app_notification_new (const gchar* message,
                                  GtkButton* button)
{
#line 42 "../src/contacts-in-app-notification.vala"
	return contacts_in_app_notification_construct (CONTACTS_TYPE_IN_APP_NOTIFICATION, message, button);
#line 158 "contacts-in-app-notification.c"
}

static gboolean
__lambda49_ (ContactsInAppNotification* self)
{
	gboolean result = FALSE;
#line 59 "../src/contacts-in-app-notification.vala"
	contacts_in_app_notification_dismiss (self);
#line 60 "../src/contacts-in-app-notification.vala"
	result = FALSE;
#line 60 "../src/contacts-in-app-notification.vala"
	return result;
#line 171 "contacts-in-app-notification.c"
}

static gboolean
___lambda49__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda49_ ((ContactsInAppNotification*) self);
#line 58 "../src/contacts-in-app-notification.vala"
	return result;
#line 181 "contacts-in-app-notification.c"
}

void
contacts_in_app_notification_show (ContactsInAppNotification* self)
{
#line 54 "../src/contacts-in-app-notification.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/contacts-in-app-notification.vala"
	GTK_WIDGET_CLASS (contacts_in_app_notification_parent_class)->show ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_revealer_get_type (), GtkRevealer));
#line 56 "../src/contacts-in-app-notification.vala"
	gtk_revealer_set_reveal_child ((GtkRevealer*) self, TRUE);
#line 58 "../src/contacts-in-app-notification.vala"
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, CONTACTS_IN_APP_NOTIFICATION_DEFAULT_KEEPALIVE, ___lambda49__gsource_func, g_object_ref (self), g_object_unref);
#line 195 "contacts-in-app-notification.c"
}

void
contacts_in_app_notification_dismiss (ContactsInAppNotification* self)
{
#line 64 "../src/contacts-in-app-notification.vala"
	g_return_if_fail (self != NULL);
#line 65 "../src/contacts-in-app-notification.vala"
	gtk_revealer_set_reveal_child ((GtkRevealer*) self, FALSE);
#line 205 "contacts-in-app-notification.c"
}

static void
contacts_in_app_notification_on_child_revealed_changed (ContactsInAppNotification* self,
                                                        GObject* o,
                                                        GParamSpec* p)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 68 "../src/contacts-in-app-notification.vala"
	g_return_if_fail (self != NULL);
#line 68 "../src/contacts-in-app-notification.vala"
	g_return_if_fail (o != NULL);
#line 68 "../src/contacts-in-app-notification.vala"
	g_return_if_fail (p != NULL);
#line 69 "../src/contacts-in-app-notification.vala"
	_tmp0_ = gtk_revealer_get_child_revealed ((GtkRevealer*) self);
#line 69 "../src/contacts-in-app-notification.vala"
	_tmp1_ = _tmp0_;
#line 69 "../src/contacts-in-app-notification.vala"
	if (!_tmp1_) {
#line 70 "../src/contacts-in-app-notification.vala"
		g_signal_emit (self, contacts_in_app_notification_signals[CONTACTS_IN_APP_NOTIFICATION_DISMISSED_SIGNAL], 0);
#line 71 "../src/contacts-in-app-notification.vala"
		gtk_widget_destroy ((GtkWidget*) self);
#line 231 "contacts-in-app-notification.c"
	}
}

static void
contacts_in_app_notification_on_close_button_clicked (ContactsInAppNotification* self,
                                                      GtkButton* close_button)
{
#line 76 "../src/contacts-in-app-notification.vala"
	g_return_if_fail (self != NULL);
#line 76 "../src/contacts-in-app-notification.vala"
	g_return_if_fail (close_button != NULL);
#line 77 "../src/contacts-in-app-notification.vala"
	contacts_in_app_notification_dismiss (self);
#line 245 "contacts-in-app-notification.c"
}

static void
_contacts_in_app_notification_on_close_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                          gpointer self)
{
#line 21 "../src/contacts-in-app-notification.vala"
	contacts_in_app_notification_on_close_button_clicked ((ContactsInAppNotification*) self, _sender);
#line 254 "contacts-in-app-notification.c"
}

GtkLabel*
contacts_in_app_notification_get_message_label (ContactsInAppNotification* self)
{
	GtkLabel* result;
	GtkLabel* _tmp0_;
#line 31 "../src/contacts-in-app-notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/contacts-in-app-notification.vala"
	_tmp0_ = self->priv->label;
#line 31 "../src/contacts-in-app-notification.vala"
	result = _tmp0_;
#line 31 "../src/contacts-in-app-notification.vala"
	return result;
#line 270 "contacts-in-app-notification.c"
}

static void
contacts_in_app_notification_class_init (ContactsInAppNotificationClass * klass,
                                         gpointer klass_data)
{
#line 21 "../src/contacts-in-app-notification.vala"
	contacts_in_app_notification_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/contacts-in-app-notification.vala"
	g_type_class_adjust_private_offset (klass, &ContactsInAppNotification_private_offset);
#line 21 "../src/contacts-in-app-notification.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_contacts_in_app_notification_get_property;
#line 21 "../src/contacts-in-app-notification.vala"
	G_OBJECT_CLASS (klass)->finalize = contacts_in_app_notification_finalize;
#line 21 "../src/contacts-in-app-notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_IN_APP_NOTIFICATION_MESSAGE_LABEL_PROPERTY, contacts_in_app_notification_properties[CONTACTS_IN_APP_NOTIFICATION_MESSAGE_LABEL_PROPERTY] = g_param_spec_object ("message-label", "message-label", "message-label", gtk_label_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/contacts-in-app-notification.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Contacts/ui/contacts-in-app-notification.ui");
#line 289 "contacts-in-app-notification.c"
	/**
	   * Fired when the notification is completely dismissed (i.e. gone).
	   */
#line 21 "../src/contacts-in-app-notification.vala"
	contacts_in_app_notification_signals[CONTACTS_IN_APP_NOTIFICATION_DISMISSED_SIGNAL] = g_signal_new ("dismissed", CONTACTS_TYPE_IN_APP_NOTIFICATION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 21 "../src/contacts-in-app-notification.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "grid", FALSE, ContactsInAppNotification_private_offset + G_STRUCT_OFFSET (ContactsInAppNotificationPrivate, grid));
#line 21 "../src/contacts-in-app-notification.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "label", FALSE, ContactsInAppNotification_private_offset + G_STRUCT_OFFSET (ContactsInAppNotificationPrivate, label));
#line 21 "../src/contacts-in-app-notification.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_close_button_clicked", G_CALLBACK(_contacts_in_app_notification_on_close_button_clicked_gtk_button_clicked));
#line 301 "contacts-in-app-notification.c"
}

static void
contacts_in_app_notification_instance_init (ContactsInAppNotification * self,
                                            gpointer klass)
{
#line 21 "../src/contacts-in-app-notification.vala"
	self->priv = contacts_in_app_notification_get_instance_private (self);
#line 21 "../src/contacts-in-app-notification.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 312 "contacts-in-app-notification.c"
}

static void
contacts_in_app_notification_finalize (GObject * obj)
{
	ContactsInAppNotification * self;
#line 21 "../src/contacts-in-app-notification.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONTACTS_TYPE_IN_APP_NOTIFICATION, ContactsInAppNotification);
#line 26 "../src/contacts-in-app-notification.vala"
	_g_object_unref0 (self->priv->grid);
#line 29 "../src/contacts-in-app-notification.vala"
	_g_object_unref0 (self->priv->label);
#line 21 "../src/contacts-in-app-notification.vala"
	G_OBJECT_CLASS (contacts_in_app_notification_parent_class)->finalize (obj);
#line 327 "contacts-in-app-notification.c"
}

GType
contacts_in_app_notification_get_type (void)
{
	static volatile gsize contacts_in_app_notification_type_id__volatile = 0;
	if (g_once_init_enter (&contacts_in_app_notification_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ContactsInAppNotificationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) contacts_in_app_notification_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContactsInAppNotification), 0, (GInstanceInitFunc) contacts_in_app_notification_instance_init, NULL };
		GType contacts_in_app_notification_type_id;
		contacts_in_app_notification_type_id = g_type_register_static (gtk_revealer_get_type (), "ContactsInAppNotification", &g_define_type_info, 0);
		ContactsInAppNotification_private_offset = g_type_add_instance_private (contacts_in_app_notification_type_id, sizeof (ContactsInAppNotificationPrivate));
		g_once_init_leave (&contacts_in_app_notification_type_id__volatile, contacts_in_app_notification_type_id);
	}
	return contacts_in_app_notification_type_id__volatile;
}

static void
_vala_contacts_in_app_notification_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	ContactsInAppNotification * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONTACTS_TYPE_IN_APP_NOTIFICATION, ContactsInAppNotification);
#line 21 "../src/contacts-in-app-notification.vala"
	switch (property_id) {
#line 21 "../src/contacts-in-app-notification.vala"
		case CONTACTS_IN_APP_NOTIFICATION_MESSAGE_LABEL_PROPERTY:
#line 21 "../src/contacts-in-app-notification.vala"
		g_value_set_object (value, contacts_in_app_notification_get_message_label (self));
#line 21 "../src/contacts-in-app-notification.vala"
		break;
#line 360 "contacts-in-app-notification.c"
		default:
#line 21 "../src/contacts-in-app-notification.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/contacts-in-app-notification.vala"
		break;
#line 366 "contacts-in-app-notification.c"
	}
}

