/* contacts-list-pane.c generated by valac 0.44.0, the Vala compiler
 * generated from contacts-list-pane.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: t; c-basic-offset: 2; tab-width: 8 -*- */
/*
 * Copyright (C) 2011 Alexander Larsson <alexl@redhat.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include "contacts.h"
#include <folks/folks.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>

#define CONTACTS_TYPE_LIST_PANE (contacts_list_pane_get_type ())
#define CONTACTS_LIST_PANE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTACTS_TYPE_LIST_PANE, ContactsListPane))
#define CONTACTS_LIST_PANE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTACTS_TYPE_LIST_PANE, ContactsListPaneClass))
#define CONTACTS_IS_LIST_PANE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTACTS_TYPE_LIST_PANE))
#define CONTACTS_IS_LIST_PANE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTACTS_TYPE_LIST_PANE))
#define CONTACTS_LIST_PANE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTACTS_TYPE_LIST_PANE, ContactsListPaneClass))

typedef struct _ContactsListPane ContactsListPane;
typedef struct _ContactsListPaneClass ContactsListPaneClass;
typedef struct _ContactsListPanePrivate ContactsListPanePrivate;

#define CONTACTS_TYPE_CONTACT_LIST (contacts_contact_list_get_type ())
#define CONTACTS_CONTACT_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTACTS_TYPE_CONTACT_LIST, ContactsContactList))
#define CONTACTS_CONTACT_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTACTS_TYPE_CONTACT_LIST, ContactsContactListClass))
#define CONTACTS_IS_CONTACT_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTACTS_TYPE_CONTACT_LIST))
#define CONTACTS_IS_CONTACT_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTACTS_TYPE_CONTACT_LIST))
#define CONTACTS_CONTACT_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTACTS_TYPE_CONTACT_LIST, ContactsContactListClass))

typedef struct _ContactsContactList ContactsContactList;
typedef struct _ContactsContactListClass ContactsContactListClass;
typedef enum  {
	CONTACTS_UI_STATE_NORMAL,
	CONTACTS_UI_STATE_SHOWING,
	CONTACTS_UI_STATE_SELECTING,
	CONTACTS_UI_STATE_UPDATING,
	CONTACTS_UI_STATE_CREATING
} ContactsUiState;

#define CONTACTS_TYPE_UI_STATE (contacts_ui_state_get_type ())
enum  {
	CONTACTS_LIST_PANE_0_PROPERTY,
	CONTACTS_LIST_PANE_STATE_PROPERTY,
	CONTACTS_LIST_PANE_NUM_PROPERTIES
};
static GParamSpec* contacts_list_pane_properties[CONTACTS_LIST_PANE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define CONTACTS_TYPE_SETTINGS (contacts_settings_get_type ())
#define CONTACTS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTACTS_TYPE_SETTINGS, ContactsSettings))
#define CONTACTS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTACTS_TYPE_SETTINGS, ContactsSettingsClass))
#define CONTACTS_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTACTS_TYPE_SETTINGS))
#define CONTACTS_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTACTS_TYPE_SETTINGS))
#define CONTACTS_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTACTS_TYPE_SETTINGS, ContactsSettingsClass))

typedef struct _ContactsSettings ContactsSettings;
typedef struct _ContactsSettingsClass ContactsSettingsClass;
enum  {
	CONTACTS_LIST_PANE_SELECTION_CHANGED_SIGNAL,
	CONTACTS_LIST_PANE_LINK_CONTACTS_SIGNAL,
	CONTACTS_LIST_PANE_DELETE_CONTACTS_SIGNAL,
	CONTACTS_LIST_PANE_CONTACTS_MARKED_SIGNAL,
	CONTACTS_LIST_PANE_NUM_SIGNALS
};
static guint contacts_list_pane_signals[CONTACTS_LIST_PANE_NUM_SIGNALS] = {0};

struct _ContactsListPane {
	GtkFrame parent_instance;
	ContactsListPanePrivate * priv;
	GtkSearchEntry* filter_entry;
};

struct _ContactsListPaneClass {
	GtkFrameClass parent_class;
};

struct _ContactsListPanePrivate {
	ContactsStore* store;
	GtkScrolledWindow* contacts_list_container;
	ContactsContactList* contacts_list;
	FolksSimpleQuery* filter_query;
	GtkButton* link_button;
	GtkButton* delete_button;
	GtkActionBar* actions_bar;
	ContactsUiState _state;
};

static gint ContactsListPane_private_offset;
static gpointer contacts_list_pane_parent_class = NULL;

GType contacts_list_pane_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ContactsListPane, g_object_unref)
GType contacts_contact_list_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ContactsContactList, g_object_unref)
GType contacts_ui_state_get_type (void) G_GNUC_CONST;
GType contacts_settings_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ContactsSettings, g_object_unref)
ContactsListPane* contacts_list_pane_new (ContactsSettings* settings,
                                          ContactsStore* contacts_store);
ContactsListPane* contacts_list_pane_construct (GType object_type,
                                                ContactsSettings* settings,
                                                ContactsStore* contacts_store);
static void contacts_list_pane_on_ui_state_changed (ContactsListPane* self,
                                             GObject* obj,
                                             GParamSpec* pspec);
static void _contacts_list_pane_on_ui_state_changed_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self);
static gchar** _vala_array_dup1 (gchar** self,
                          int length);
static void _vala_array_add1 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
ContactsContactList* contacts_contact_list_new (ContactsSettings* settings,
                                                ContactsStore* store,
                                                FolksQuery* query);
ContactsContactList* contacts_contact_list_construct (GType object_type,
                                                      ContactsSettings* settings,
                                                      ContactsStore* store,
                                                      FolksQuery* query);
static void __lambda9_ (ContactsListPane* self,
                 ContactsContactList* l,
                 ContactsContact* contact);
static void ___lambda9__contacts_contact_list_selection_changed (ContactsContactList* _sender,
                                                          ContactsContact* contact,
                                                          gpointer self);
static void __lambda10_ (ContactsListPane* self,
                  gint nr_contacts_marked);
static void ___lambda10__contacts_contact_list_contacts_marked (ContactsContactList* _sender,
                                                         gint contacts_marked,
                                                         gpointer self);
ContactsUiState contacts_list_pane_get_state (ContactsListPane* self);
gboolean contacts_ui_state_editing (ContactsUiState self);
static void contacts_list_pane_filter_entry_changed (ContactsListPane* self,
                                              GtkEditable* editable);
static void _contacts_list_pane_filter_entry_changed_gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                                               gpointer self);
void contacts_list_pane_select_contact (ContactsListPane* self,
                                        ContactsContact* contact);
void contacts_contact_list_select_contact (ContactsContactList* self,
                                           ContactsContact* contact);
static void contacts_list_pane_on_link_button_clicked (ContactsListPane* self,
                                                GtkButton* link_button);
GeeLinkedList* contacts_contact_list_get_marked_contacts (ContactsContactList* self);
static void _contacts_list_pane_on_link_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                    gpointer self);
static void contacts_list_pane_on_delete_button_clicked (ContactsListPane* self,
                                                  GtkButton* delete_button);
static void _contacts_list_pane_on_delete_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                      gpointer self);
static void contacts_list_pane_real_get_preferred_width (GtkWidget* base,
                                                  gint* minimum_width,
                                                  gint* natural_width);
void contacts_list_pane_set_state (ContactsListPane* self,
                                   ContactsUiState value);
static void contacts_list_pane_finalize (GObject * obj);
static void _vala_contacts_list_pane_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_contacts_list_pane_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
contacts_list_pane_get_instance_private (ContactsListPane* self)
{
	return G_STRUCT_MEMBER_P (self, ContactsListPane_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 52 "../src/contacts-list-pane.vala"
	return self ? g_object_ref (self) : NULL;
#line 205 "contacts-list-pane.c"
}

static void
_contacts_list_pane_on_ui_state_changed_g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self)
{
#line 53 "../src/contacts-list-pane.vala"
	contacts_list_pane_on_ui_state_changed ((ContactsListPane*) self, _sender, pspec);
#line 215 "contacts-list-pane.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
#line 56 "../src/contacts-list-pane.vala"
	result = g_new0 (gchar*, length + 1);
#line 56 "../src/contacts-list-pane.vala"
	for (i = 0; i < length; i++) {
#line 228 "contacts-list-pane.c"
		gchar* _tmp0_;
#line 56 "../src/contacts-list-pane.vala"
		_tmp0_ = g_strdup (self[i]);
#line 56 "../src/contacts-list-pane.vala"
		result[i] = _tmp0_;
#line 234 "contacts-list-pane.c"
	}
#line 56 "../src/contacts-list-pane.vala"
	return result;
#line 238 "contacts-list-pane.c"
}

static void
_vala_array_add1 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 58 "../src/contacts-list-pane.vala"
	if ((*length) == (*size)) {
#line 58 "../src/contacts-list-pane.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 58 "../src/contacts-list-pane.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 253 "contacts-list-pane.c"
	}
#line 58 "../src/contacts-list-pane.vala"
	(*array)[(*length)++] = value;
#line 58 "../src/contacts-list-pane.vala"
	(*array)[*length] = NULL;
#line 259 "contacts-list-pane.c"
}

static void
__lambda9_ (ContactsListPane* self,
            ContactsContactList* l,
            ContactsContact* contact)
{
#line 67 "../src/contacts-list-pane.vala"
	g_return_if_fail (l != NULL);
#line 68 "../src/contacts-list-pane.vala"
	g_signal_emit (self, contacts_list_pane_signals[CONTACTS_LIST_PANE_SELECTION_CHANGED_SIGNAL], 0, contact);
#line 271 "contacts-list-pane.c"
}

static void
___lambda9__contacts_contact_list_selection_changed (ContactsContactList* _sender,
                                                     ContactsContact* contact,
                                                     gpointer self)
{
#line 67 "../src/contacts-list-pane.vala"
	__lambda9_ ((ContactsListPane*) self, _sender, contact);
#line 281 "contacts-list-pane.c"
}

static void
__lambda10_ (ContactsListPane* self,
             gint nr_contacts_marked)
{
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
#line 72 "../src/contacts-list-pane.vala"
	_tmp0_ = self->priv->delete_button;
#line 72 "../src/contacts-list-pane.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, nr_contacts_marked > 0);
#line 73 "../src/contacts-list-pane.vala"
	_tmp1_ = self->priv->link_button;
#line 73 "../src/contacts-list-pane.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, nr_contacts_marked > 1);
#line 74 "../src/contacts-list-pane.vala"
	g_signal_emit (self, contacts_list_pane_signals[CONTACTS_LIST_PANE_CONTACTS_MARKED_SIGNAL], 0, nr_contacts_marked);
#line 300 "contacts-list-pane.c"
}

static void
___lambda10__contacts_contact_list_contacts_marked (ContactsContactList* _sender,
                                                    gint contacts_marked,
                                                    gpointer self)
{
#line 71 "../src/contacts-list-pane.vala"
	__lambda10_ ((ContactsListPane*) self, contacts_marked);
#line 310 "contacts-list-pane.c"
}

ContactsListPane*
contacts_list_pane_construct (GType object_type,
                              ContactsSettings* settings,
                              ContactsStore* contacts_store)
{
	ContactsListPane * self = NULL;
	ContactsStore* _tmp0_;
	gchar** filtered_fields = NULL;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gint filtered_fields_length1;
	gint _filtered_fields_size_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	FolksSimpleQuery* _tmp6_;
	FolksSimpleQuery* _tmp7_;
	ContactsContactList* _tmp8_;
	ContactsContactList* _tmp9_;
	GtkScrolledWindow* _tmp10_;
	ContactsContactList* _tmp11_;
	ContactsContactList* _tmp12_;
	ContactsContactList* _tmp13_;
#line 51 "../src/contacts-list-pane.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 51 "../src/contacts-list-pane.vala"
	g_return_val_if_fail (contacts_store != NULL, NULL);
#line 51 "../src/contacts-list-pane.vala"
	self = (ContactsListPane*) g_object_new (object_type, NULL);
#line 52 "../src/contacts-list-pane.vala"
	_tmp0_ = _g_object_ref0 (contacts_store);
#line 52 "../src/contacts-list-pane.vala"
	_g_object_unref0 (self->priv->store);
#line 52 "../src/contacts-list-pane.vala"
	self->priv->store = _tmp0_;
#line 53 "../src/contacts-list-pane.vala"
	g_signal_connect_object ((GObject*) self, "notify::state", (GCallback) _contacts_list_pane_on_ui_state_changed_g_object_notify, self, 0);
#line 56 "../src/contacts-list-pane.vala"
	_tmp1_ = (FOLKS_QUERY_MATCH_FIELDS_NAMES != NULL) ? _vala_array_dup1 (FOLKS_QUERY_MATCH_FIELDS_NAMES, G_N_ELEMENTS (FOLKS_QUERY_MATCH_FIELDS_NAMES)) : ((gpointer) FOLKS_QUERY_MATCH_FIELDS_NAMES);
#line 56 "../src/contacts-list-pane.vala"
	_tmp1__length1 = G_N_ELEMENTS (FOLKS_QUERY_MATCH_FIELDS_NAMES);
#line 56 "../src/contacts-list-pane.vala"
	filtered_fields = _tmp1_;
#line 56 "../src/contacts-list-pane.vala"
	filtered_fields_length1 = _tmp1__length1;
#line 56 "../src/contacts-list-pane.vala"
	_filtered_fields_size_ = filtered_fields_length1;
#line 359 "contacts-list-pane.c"
	{
		const gchar** field_collection = NULL;
		gint field_collection_length1 = 0;
		gint _field_collection_size_ = 0;
		gint field_it = 0;
#line 57 "../src/contacts-list-pane.vala"
		field_collection = FOLKS_QUERY_MATCH_FIELDS_ADDRESSES;
#line 57 "../src/contacts-list-pane.vala"
		field_collection_length1 = G_N_ELEMENTS (FOLKS_QUERY_MATCH_FIELDS_ADDRESSES);
#line 57 "../src/contacts-list-pane.vala"
		for (field_it = 0; field_it < G_N_ELEMENTS (FOLKS_QUERY_MATCH_FIELDS_ADDRESSES); field_it = field_it + 1) {
#line 371 "contacts-list-pane.c"
			const gchar* field = NULL;
#line 57 "../src/contacts-list-pane.vala"
			field = field_collection[field_it];
#line 375 "contacts-list-pane.c"
			{
				gchar** _tmp2_;
				gint _tmp2__length1;
				const gchar* _tmp3_;
				gchar* _tmp4_;
#line 58 "../src/contacts-list-pane.vala"
				_tmp2_ = filtered_fields;
#line 58 "../src/contacts-list-pane.vala"
				_tmp2__length1 = filtered_fields_length1;
#line 58 "../src/contacts-list-pane.vala"
				_tmp3_ = field;
#line 58 "../src/contacts-list-pane.vala"
				_tmp4_ = g_strdup (_tmp3_);
#line 58 "../src/contacts-list-pane.vala"
				_vala_array_add1 (&filtered_fields, &filtered_fields_length1, &_filtered_fields_size_, _tmp4_);
#line 391 "contacts-list-pane.c"
			}
		}
	}
#line 59 "../src/contacts-list-pane.vala"
	_tmp5_ = filtered_fields;
#line 59 "../src/contacts-list-pane.vala"
	_tmp5__length1 = filtered_fields_length1;
#line 59 "../src/contacts-list-pane.vala"
	_tmp6_ = folks_simple_query_new ("", _tmp5_, _tmp5__length1);
#line 59 "../src/contacts-list-pane.vala"
	_g_object_unref0 (self->priv->filter_query);
#line 59 "../src/contacts-list-pane.vala"
	self->priv->filter_query = _tmp6_;
#line 63 "../src/contacts-list-pane.vala"
	_tmp7_ = self->priv->filter_query;
#line 63 "../src/contacts-list-pane.vala"
	_tmp8_ = contacts_contact_list_new (settings, contacts_store, (FolksQuery*) _tmp7_);
#line 63 "../src/contacts-list-pane.vala"
	g_object_ref_sink (_tmp8_);
#line 63 "../src/contacts-list-pane.vala"
	_g_object_unref0 (self->priv->contacts_list);
#line 63 "../src/contacts-list-pane.vala"
	self->priv->contacts_list = _tmp8_;
#line 64 "../src/contacts-list-pane.vala"
	_tmp9_ = self->priv->contacts_list;
#line 64 "../src/contacts-list-pane.vala"
	g_object_bind_property_with_closures ((GObject*) self, "state", (GObject*) _tmp9_, "state", G_BINDING_BIDIRECTIONAL | G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 65 "../src/contacts-list-pane.vala"
	_tmp10_ = self->priv->contacts_list_container;
#line 65 "../src/contacts-list-pane.vala"
	_tmp11_ = self->priv->contacts_list;
#line 65 "../src/contacts-list-pane.vala"
	gtk_container_add ((GtkContainer*) _tmp10_, (GtkWidget*) _tmp11_);
#line 67 "../src/contacts-list-pane.vala"
	_tmp12_ = self->priv->contacts_list;
#line 67 "../src/contacts-list-pane.vala"
	g_signal_connect_object (_tmp12_, "selection-changed", (GCallback) ___lambda9__contacts_contact_list_selection_changed, self, 0);
#line 71 "../src/contacts-list-pane.vala"
	_tmp13_ = self->priv->contacts_list;
#line 71 "../src/contacts-list-pane.vala"
	g_signal_connect_object (_tmp13_, "contacts-marked", (GCallback) ___lambda10__contacts_contact_list_contacts_marked, self, 0);
#line 51 "../src/contacts-list-pane.vala"
	filtered_fields = (_vala_array_free (filtered_fields, filtered_fields_length1, (GDestroyNotify) g_free), NULL);
#line 51 "../src/contacts-list-pane.vala"
	return self;
#line 437 "contacts-list-pane.c"
}

ContactsListPane*
contacts_list_pane_new (ContactsSettings* settings,
                        ContactsStore* contacts_store)
{
#line 51 "../src/contacts-list-pane.vala"
	return contacts_list_pane_construct (CONTACTS_TYPE_LIST_PANE, settings, contacts_store);
#line 446 "contacts-list-pane.c"
}

static void
contacts_list_pane_on_ui_state_changed (ContactsListPane* self,
                                        GObject* obj,
                                        GParamSpec* pspec)
{
	GtkSearchEntry* _tmp0_;
	ContactsContactList* _tmp1_;
	ContactsUiState _tmp2_;
	GtkActionBar* _tmp3_;
	ContactsUiState _tmp4_;
#line 78 "../src/contacts-list-pane.vala"
	g_return_if_fail (self != NULL);
#line 78 "../src/contacts-list-pane.vala"
	g_return_if_fail (obj != NULL);
#line 78 "../src/contacts-list-pane.vala"
	g_return_if_fail (pspec != NULL);
#line 80 "../src/contacts-list-pane.vala"
	_tmp0_ = self->filter_entry;
#line 80 "../src/contacts-list-pane.vala"
	_tmp1_ = self->priv->contacts_list;
#line 80 "../src/contacts-list-pane.vala"
	_tmp2_ = self->priv->_state;
#line 80 "../src/contacts-list-pane.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, !contacts_ui_state_editing (_tmp2_));
#line 80 "../src/contacts-list-pane.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, !contacts_ui_state_editing (_tmp2_));
#line 84 "../src/contacts-list-pane.vala"
	_tmp3_ = self->priv->actions_bar;
#line 84 "../src/contacts-list-pane.vala"
	_tmp4_ = self->priv->_state;
#line 84 "../src/contacts-list-pane.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp3_, _tmp4_ == CONTACTS_UI_STATE_SELECTING);
#line 481 "contacts-list-pane.c"
}

static void
contacts_list_pane_filter_entry_changed (ContactsListPane* self,
                                         GtkEditable* editable)
{
	FolksSimpleQuery* _tmp0_;
	GtkSearchEntry* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 88 "../src/contacts-list-pane.vala"
	g_return_if_fail (self != NULL);
#line 88 "../src/contacts-list-pane.vala"
	g_return_if_fail (editable != NULL);
#line 89 "../src/contacts-list-pane.vala"
	_tmp0_ = self->priv->filter_query;
#line 89 "../src/contacts-list-pane.vala"
	_tmp1_ = self->filter_entry;
#line 89 "../src/contacts-list-pane.vala"
	_tmp2_ = gtk_entry_get_text ((GtkEntry*) _tmp1_);
#line 89 "../src/contacts-list-pane.vala"
	_tmp3_ = _tmp2_;
#line 89 "../src/contacts-list-pane.vala"
	folks_simple_query_set_query_string (_tmp0_, _tmp3_);
#line 506 "contacts-list-pane.c"
}

static void
_contacts_list_pane_filter_entry_changed_gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                                          gpointer self)
{
#line 24 "../src/contacts-list-pane.vala"
	contacts_list_pane_filter_entry_changed ((ContactsListPane*) self, _sender);
#line 515 "contacts-list-pane.c"
}

void
contacts_list_pane_select_contact (ContactsListPane* self,
                                   ContactsContact* contact)
{
	ContactsContactList* _tmp0_;
#line 92 "../src/contacts-list-pane.vala"
	g_return_if_fail (self != NULL);
#line 93 "../src/contacts-list-pane.vala"
	_tmp0_ = self->priv->contacts_list;
#line 93 "../src/contacts-list-pane.vala"
	contacts_contact_list_select_contact (_tmp0_, contact);
#line 529 "contacts-list-pane.c"
}

static void
contacts_list_pane_on_link_button_clicked (ContactsListPane* self,
                                           GtkButton* link_button)
{
	ContactsContactList* _tmp0_;
	GeeLinkedList* _tmp1_;
	GeeLinkedList* _tmp2_;
#line 97 "../src/contacts-list-pane.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/contacts-list-pane.vala"
	g_return_if_fail (link_button != NULL);
#line 98 "../src/contacts-list-pane.vala"
	_tmp0_ = self->priv->contacts_list;
#line 98 "../src/contacts-list-pane.vala"
	_tmp1_ = contacts_contact_list_get_marked_contacts (_tmp0_);
#line 98 "../src/contacts-list-pane.vala"
	_tmp2_ = _tmp1_;
#line 98 "../src/contacts-list-pane.vala"
	g_signal_emit (self, contacts_list_pane_signals[CONTACTS_LIST_PANE_LINK_CONTACTS_SIGNAL], 0, _tmp2_);
#line 98 "../src/contacts-list-pane.vala"
	_g_object_unref0 (_tmp2_);
#line 553 "contacts-list-pane.c"
}

static void
_contacts_list_pane_on_link_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                               gpointer self)
{
#line 24 "../src/contacts-list-pane.vala"
	contacts_list_pane_on_link_button_clicked ((ContactsListPane*) self, _sender);
#line 562 "contacts-list-pane.c"
}

static void
contacts_list_pane_on_delete_button_clicked (ContactsListPane* self,
                                             GtkButton* delete_button)
{
	GeeLinkedList* marked_contacts = NULL;
	ContactsContactList* _tmp0_;
	GeeLinkedList* _tmp1_;
	GeeLinkedList* _tmp10_;
#line 102 "../src/contacts-list-pane.vala"
	g_return_if_fail (self != NULL);
#line 102 "../src/contacts-list-pane.vala"
	g_return_if_fail (delete_button != NULL);
#line 103 "../src/contacts-list-pane.vala"
	_tmp0_ = self->priv->contacts_list;
#line 103 "../src/contacts-list-pane.vala"
	_tmp1_ = contacts_contact_list_get_marked_contacts (_tmp0_);
#line 103 "../src/contacts-list-pane.vala"
	marked_contacts = _tmp1_;
#line 583 "contacts-list-pane.c"
	{
		GeeLinkedList* _c_list = NULL;
		GeeLinkedList* _tmp2_;
		GeeLinkedList* _tmp3_;
		gint _c_size = 0;
		GeeLinkedList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _c_index = 0;
#line 104 "../src/contacts-list-pane.vala"
		_tmp2_ = marked_contacts;
#line 104 "../src/contacts-list-pane.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 104 "../src/contacts-list-pane.vala"
		_c_list = _tmp3_;
#line 104 "../src/contacts-list-pane.vala"
		_tmp4_ = _c_list;
#line 104 "../src/contacts-list-pane.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 104 "../src/contacts-list-pane.vala"
		_tmp6_ = _tmp5_;
#line 104 "../src/contacts-list-pane.vala"
		_c_size = _tmp6_;
#line 104 "../src/contacts-list-pane.vala"
		_c_index = -1;
#line 104 "../src/contacts-list-pane.vala"
		while (TRUE) {
#line 611 "contacts-list-pane.c"
			ContactsContact* c = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			ContactsContact* _tmp9_;
#line 104 "../src/contacts-list-pane.vala"
			_c_index = _c_index + 1;
#line 104 "../src/contacts-list-pane.vala"
			if (!(_c_index < _c_size)) {
#line 104 "../src/contacts-list-pane.vala"
				break;
#line 622 "contacts-list-pane.c"
			}
#line 104 "../src/contacts-list-pane.vala"
			_tmp7_ = _c_list;
#line 104 "../src/contacts-list-pane.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _c_index);
#line 104 "../src/contacts-list-pane.vala"
			c = (ContactsContact*) _tmp8_;
#line 105 "../src/contacts-list-pane.vala"
			_tmp9_ = c;
#line 105 "../src/contacts-list-pane.vala"
			contacts_contact_set_hidden (_tmp9_, TRUE);
#line 104 "../src/contacts-list-pane.vala"
			_g_object_unref0 (c);
#line 636 "contacts-list-pane.c"
		}
#line 104 "../src/contacts-list-pane.vala"
		_g_object_unref0 (_c_list);
#line 640 "contacts-list-pane.c"
	}
#line 106 "../src/contacts-list-pane.vala"
	_tmp10_ = marked_contacts;
#line 106 "../src/contacts-list-pane.vala"
	g_signal_emit (self, contacts_list_pane_signals[CONTACTS_LIST_PANE_DELETE_CONTACTS_SIGNAL], 0, _tmp10_);
#line 102 "../src/contacts-list-pane.vala"
	_g_object_unref0 (marked_contacts);
#line 648 "contacts-list-pane.c"
}

static void
_contacts_list_pane_on_delete_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                 gpointer self)
{
#line 24 "../src/contacts-list-pane.vala"
	contacts_list_pane_on_delete_button_clicked ((ContactsListPane*) self, _sender);
#line 657 "contacts-list-pane.c"
}

static void
contacts_list_pane_real_get_preferred_width (GtkWidget* base,
                                             gint* minimum_width,
                                             gint* natural_width)
{
	ContactsListPane * self;
	gint _vala_minimum_width = 0;
	gint _vala_natural_width = 0;
#line 110 "../src/contacts-list-pane.vala"
	self = (ContactsListPane*) base;
#line 111 "../src/contacts-list-pane.vala"
	_vala_natural_width = 300;
#line 111 "../src/contacts-list-pane.vala"
	_vala_minimum_width = _vala_natural_width;
#line 110 "../src/contacts-list-pane.vala"
	if (minimum_width) {
#line 110 "../src/contacts-list-pane.vala"
		*minimum_width = _vala_minimum_width;
#line 678 "contacts-list-pane.c"
	}
#line 110 "../src/contacts-list-pane.vala"
	if (natural_width) {
#line 110 "../src/contacts-list-pane.vala"
		*natural_width = _vala_natural_width;
#line 684 "contacts-list-pane.c"
	}
}

ContactsUiState
contacts_list_pane_get_state (ContactsListPane* self)
{
	ContactsUiState result;
	ContactsUiState _tmp0_;
#line 44 "../src/contacts-list-pane.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 44 "../src/contacts-list-pane.vala"
	_tmp0_ = self->priv->_state;
#line 44 "../src/contacts-list-pane.vala"
	result = _tmp0_;
#line 44 "../src/contacts-list-pane.vala"
	return result;
#line 701 "contacts-list-pane.c"
}

void
contacts_list_pane_set_state (ContactsListPane* self,
                              ContactsUiState value)
{
#line 44 "../src/contacts-list-pane.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/contacts-list-pane.vala"
	if (contacts_list_pane_get_state (self) != value) {
#line 44 "../src/contacts-list-pane.vala"
		self->priv->_state = value;
#line 44 "../src/contacts-list-pane.vala"
		g_object_notify_by_pspec ((GObject *) self, contacts_list_pane_properties[CONTACTS_LIST_PANE_STATE_PROPERTY]);
#line 716 "contacts-list-pane.c"
	}
}

static void
contacts_list_pane_class_init (ContactsListPaneClass * klass,
                               gpointer klass_data)
{
#line 24 "../src/contacts-list-pane.vala"
	contacts_list_pane_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/contacts-list-pane.vala"
	g_type_class_adjust_private_offset (klass, &ContactsListPane_private_offset);
#line 24 "../src/contacts-list-pane.vala"
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget*, gint*, gint*)) contacts_list_pane_real_get_preferred_width;
#line 24 "../src/contacts-list-pane.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_contacts_list_pane_get_property;
#line 24 "../src/contacts-list-pane.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_contacts_list_pane_set_property;
#line 24 "../src/contacts-list-pane.vala"
	G_OBJECT_CLASS (klass)->finalize = contacts_list_pane_finalize;
#line 24 "../src/contacts-list-pane.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONTACTS_LIST_PANE_STATE_PROPERTY, contacts_list_pane_properties[CONTACTS_LIST_PANE_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", CONTACTS_TYPE_UI_STATE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/contacts-list-pane.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Contacts/ui/contacts-list-pane.ui");
#line 24 "../src/contacts-list-pane.vala"
	contacts_list_pane_signals[CONTACTS_LIST_PANE_SELECTION_CHANGED_SIGNAL] = g_signal_new ("selection-changed", CONTACTS_TYPE_LIST_PANE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, CONTACTS_TYPE_CONTACT);
#line 24 "../src/contacts-list-pane.vala"
	contacts_list_pane_signals[CONTACTS_LIST_PANE_LINK_CONTACTS_SIGNAL] = g_signal_new ("link-contacts", CONTACTS_TYPE_LIST_PANE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_LINKED_LIST);
#line 24 "../src/contacts-list-pane.vala"
	contacts_list_pane_signals[CONTACTS_LIST_PANE_DELETE_CONTACTS_SIGNAL] = g_signal_new ("delete-contacts", CONTACTS_TYPE_LIST_PANE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_LINKED_LIST);
#line 24 "../src/contacts-list-pane.vala"
	contacts_list_pane_signals[CONTACTS_LIST_PANE_CONTACTS_MARKED_SIGNAL] = g_signal_new ("contacts-marked", CONTACTS_TYPE_LIST_PANE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 24 "../src/contacts-list-pane.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "contacts_list_container", FALSE, ContactsListPane_private_offset + G_STRUCT_OFFSET (ContactsListPanePrivate, contacts_list_container));
#line 24 "../src/contacts-list-pane.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "filter_entry", FALSE, G_STRUCT_OFFSET (ContactsListPane, filter_entry));
#line 24 "../src/contacts-list-pane.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "link_button", FALSE, ContactsListPane_private_offset + G_STRUCT_OFFSET (ContactsListPanePrivate, link_button));
#line 24 "../src/contacts-list-pane.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "delete_button", FALSE, ContactsListPane_private_offset + G_STRUCT_OFFSET (ContactsListPanePrivate, delete_button));
#line 24 "../src/contacts-list-pane.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "actions_bar", FALSE, ContactsListPane_private_offset + G_STRUCT_OFFSET (ContactsListPanePrivate, actions_bar));
#line 24 "../src/contacts-list-pane.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "filter_entry_changed", G_CALLBACK(_contacts_list_pane_filter_entry_changed_gtk_search_entry_search_changed));
#line 24 "../src/contacts-list-pane.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_link_button_clicked", G_CALLBACK(_contacts_list_pane_on_link_button_clicked_gtk_button_clicked));
#line 24 "../src/contacts-list-pane.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_delete_button_clicked", G_CALLBACK(_contacts_list_pane_on_delete_button_clicked_gtk_button_clicked));
#line 764 "contacts-list-pane.c"
}

static void
contacts_list_pane_instance_init (ContactsListPane * self,
                                  gpointer klass)
{
#line 24 "../src/contacts-list-pane.vala"
	self->priv = contacts_list_pane_get_instance_private (self);
#line 24 "../src/contacts-list-pane.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 775 "contacts-list-pane.c"
}

static void
contacts_list_pane_finalize (GObject * obj)
{
	ContactsListPane * self;
#line 24 "../src/contacts-list-pane.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONTACTS_TYPE_LIST_PANE, ContactsListPane);
#line 25 "../src/contacts-list-pane.vala"
	_g_object_unref0 (self->priv->store);
#line 28 "../src/contacts-list-pane.vala"
	_g_object_unref0 (self->priv->contacts_list_container);
#line 29 "../src/contacts-list-pane.vala"
	_g_object_unref0 (self->priv->contacts_list);
#line 32 "../src/contacts-list-pane.vala"
	_g_object_unref0 (self->filter_entry);
#line 33 "../src/contacts-list-pane.vala"
	_g_object_unref0 (self->priv->filter_query);
#line 36 "../src/contacts-list-pane.vala"
	_g_object_unref0 (self->priv->link_button);
#line 39 "../src/contacts-list-pane.vala"
	_g_object_unref0 (self->priv->delete_button);
#line 42 "../src/contacts-list-pane.vala"
	_g_object_unref0 (self->priv->actions_bar);
#line 24 "../src/contacts-list-pane.vala"
	G_OBJECT_CLASS (contacts_list_pane_parent_class)->finalize (obj);
#line 802 "contacts-list-pane.c"
}

GType
contacts_list_pane_get_type (void)
{
	static volatile gsize contacts_list_pane_type_id__volatile = 0;
	if (g_once_init_enter (&contacts_list_pane_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ContactsListPaneClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) contacts_list_pane_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContactsListPane), 0, (GInstanceInitFunc) contacts_list_pane_instance_init, NULL };
		GType contacts_list_pane_type_id;
		contacts_list_pane_type_id = g_type_register_static (gtk_frame_get_type (), "ContactsListPane", &g_define_type_info, 0);
		ContactsListPane_private_offset = g_type_add_instance_private (contacts_list_pane_type_id, sizeof (ContactsListPanePrivate));
		g_once_init_leave (&contacts_list_pane_type_id__volatile, contacts_list_pane_type_id);
	}
	return contacts_list_pane_type_id__volatile;
}

static void
_vala_contacts_list_pane_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	ContactsListPane * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONTACTS_TYPE_LIST_PANE, ContactsListPane);
#line 24 "../src/contacts-list-pane.vala"
	switch (property_id) {
#line 24 "../src/contacts-list-pane.vala"
		case CONTACTS_LIST_PANE_STATE_PROPERTY:
#line 24 "../src/contacts-list-pane.vala"
		g_value_set_enum (value, contacts_list_pane_get_state (self));
#line 24 "../src/contacts-list-pane.vala"
		break;
#line 835 "contacts-list-pane.c"
		default:
#line 24 "../src/contacts-list-pane.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/contacts-list-pane.vala"
		break;
#line 841 "contacts-list-pane.c"
	}
}

static void
_vala_contacts_list_pane_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	ContactsListPane * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CONTACTS_TYPE_LIST_PANE, ContactsListPane);
#line 24 "../src/contacts-list-pane.vala"
	switch (property_id) {
#line 24 "../src/contacts-list-pane.vala"
		case CONTACTS_LIST_PANE_STATE_PROPERTY:
#line 24 "../src/contacts-list-pane.vala"
		contacts_list_pane_set_state (self, g_value_get_enum (value));
#line 24 "../src/contacts-list-pane.vala"
		break;
#line 861 "contacts-list-pane.c"
		default:
#line 24 "../src/contacts-list-pane.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/contacts-list-pane.vala"
		break;
#line 867 "contacts-list-pane.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

